`line 1 "F:\verilog\bench\verilator_sim_benchmarks\bench\k68_testrom.v"



































`timescale 1ns / 10ps





module k68_testrom (
   
   dat_o, 
   
   add_i
   );
   
   input [31:0] add_i;
   output [31:0] dat_o;

   
   reg [31:0] 	 mem [0:10240];

   wire [9:0] 	 add;

   assign 	 add = add_i[11:2];
 	 
   
   initial begin
`line 1 "F:\verilog\bench\verilator_sim_benchmarks\bench\test.rom.vh"
mem[00]=32'h02000060;
mem[01]=32'h00007C2E;
mem[02]=32'hBC2E0001;
mem[03]=32'h00020000;
mem[04]=32'h00003C2F;
mem[05]=32'hFC2E0003;
mem[06]=32'h00040000;
mem[07]=32'h0000BC2E;
mem[08]=32'h00610005;
mem[09]=32'h00610A00;
mem[10]=32'h0060A400;
mem[11]=32'h7C20D200;
mem[12]=32'h020001FF;
mem[13]=32'h0100BC10;
mem[14]=32'h01FF7C20;
mem[15]=32'hBC100300;
mem[16]=32'h7C200100;
mem[17]=32'h020002FF;
mem[18]=32'h0100BC10;
mem[19]=32'h02FF7C20;
mem[20]=32'hBC100300;
mem[21]=32'h754E0100;
mem[22]=32'h01FF7C20;
mem[23]=32'h10100100;
mem[24]=32'h01000002;
mem[25]=32'h0061754E;
mem[26]=32'h0067F0FF;
mem[27]=32'h7C20FAFF;
mem[28]=32'h0001FFFF;
mem[29]=32'h754E1012;
mem[30]=32'h01FF7C20;
mem[31]=32'h10100100;
mem[32]=32'h02000002;
mem[33]=32'hF8FF0066;
mem[34]=32'h01FF7C20;
mem[35]=32'h81100000;
mem[36]=32'h7C20754E;
mem[37]=32'h010002FF;
mem[38]=32'h00021010;
mem[39]=32'h754E0100;
mem[40]=32'hF0FF0061;
mem[41]=32'hFAFF0067;
mem[42]=32'h02FF7C20;
mem[43]=32'h10120000;
mem[44]=32'h7C20754E;
mem[45]=32'h010002FF;
mem[46]=32'h00021010;
mem[47]=32'h00670200;
mem[48]=32'h7C20F8FF;
mem[49]=32'h000002FF;
mem[50]=32'h754E8110;
mem[51]=32'h4B003C12;
mem[52]=32'hA6FF0061;
mem[53]=32'hDCFF0061;
mem[54]=32'h36003C12;
mem[55]=32'h9AFF0061;
mem[56]=32'hD0FF0061;
mem[57]=32'h68003C12;
mem[58]=32'h8EFF0061;
mem[59]=32'hC4FF0061;
mem[60]=32'h0D003C12;
mem[61]=32'h82FF0061;
mem[62]=32'hB8FF0061;
mem[63]=32'h0061754E;
mem[64]=32'h006758FF;
mem[65]=32'h00610E00;
mem[66]=32'h00678AFF;
mem[67]=32'h00601400;
mem[68]=32'h0061EEFF;
mem[69]=32'h006152FF;
mem[70]=32'h00611800;
mem[71]=32'h754E96FF;
mem[72]=32'h7EFF0061;
mem[73]=32'h08000061;
mem[74]=32'h4EFF0061;
mem[75]=32'h754E754E;
mem[76]=32'h0000754E;

`line 61 "F:\verilog\bench\verilator_sim_benchmarks\bench\k68_testrom.v"

   end
      
   assign  dat_o = mem[add];

   
      
endmodule 



`line 1 "F:\verilog\bench\verilator_sim_benchmarks\bench\bench.v"



































`timescale 1ns / 10ps

module bench;

   reg 	       clk,arbclk_i,rst;
   
   k68_soc_test k68_soc_test
     (
      
      .clk				(clk),
      .rst				(rst),
      .arbclk_i				(arbclk_i)); 
   

   initial begin
   //   $dumpfile("foo.vcd");
     // $dumpvars(99,bench);
      clk = 1;
      arbclk_i = 1;
      rst = 0;
      #40 rst = 1;
     
  #100000000;
      $finish;
   end
   
   initial forever begin
      #5 clk = ~clk;
   end

   initial forever begin
      #1 arbclk_i = ~arbclk_i;
   end

endmodule


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\bench\k68_soc_test.v"



































`timescale 1ns / 10ps

module k68_soc_test (
   
   dat_i, 
   
   clk, rst, arbclk_i
   ) ;
   
   wire [31:0] add_o;
   wire [31:0] p_dat_i,m_dat_i,dat_o;
   output [31:0]  dat_i;  
   reg [31:0]  dat_i;
   
   wire [1:0]  rts,tx;
   wire        we;
      
   input       clk,rst,arbclk_i;
   
   wire        unused_clk_o, unused_rst_o;

   k68_soc dut0 (
		 .add_o(add_o),
		 .dat_o(dat_o),
		 .dat_i(dat_i),
		 .we_o(we),
		 .tx_o(tx),.rts_o(rts),
		 .rx_i(tx),.cts_i(rts),
		 .clk_i(clk), .rst_i(rst),
		 .arbclk_i(arbclk_i),
		 .clk_o(unused_clk_o), .rst_o(unused_rst_o),
		 .int_i(3'b0)
		 );
    
   k68_testrom prog0 (
		      .add_i(add_o),
		      .dat_o(p_dat_i)
		      );

   k68_testram data0 (
		      .add_i(add_o),
		      .dat_o(m_dat_i),
		      .dat_i(dat_o),
		      .we_i(we)
		      );
      
   always @(add_o or m_dat_i or p_dat_i) begin
      if (add_o[31])
	dat_i = m_dat_i;
      else
	dat_i = p_dat_i;
   end

  
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\bench\k68_testram.v"



































`timescale 1ns / 10ps

module k68_testram (
   
   dat_o, 
   
   add_i, dat_i, we_i
   );
   
   input [31:0] add_i,dat_i;
   output [31:0] dat_o;
   input 	 we_i;
   
   reg [31:0] 	 mem [10240:0];
   wire [9:0] 	 add;

   assign 	 add = add_i[11:2];
   
   assign  dat_o = mem[add];

   always @(add or dat_i or we_i)
     if (we_i) mem[add] = dat_i;
   
      
endmodule 



`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\timescale.v"
`timescale 1ns / 10ps


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_adder.v"




































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 37 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_adder.v"





module k68_adder (
   
   res, 
   
   src, dst
   ) ;
   parameter dw =  6'd32;

   output [dw:0] res;
   input [dw-1:0] src, dst;
   reg [dw:0] 	  res;

   always @(dst or src) begin
      res <= src + dst;
   end
      
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_appl.v"






















































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 55 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_appl.v"


module k68_appl (
   
   tx_o, rts_o, clk_o, dbg_o, 
   
   clk_i, rst_i, int_i, rx_i, cts_i
   ) ;

   parameter aw =  6'd32;
   parameter dw =  6'd32;

   input clk_i,rst_i;
   input [2:0] 	   int_i;
   
   wire [aw-1:0] add_o;
   wire [dw-1:0] m_dat_i;
   wire [dw-1:0] dat_o;
   wire [dw-1:0] p_dat_i;
   wire [dw-1:0] dat_i;
   wire 	 we_o;
   
   input [1:0] 	 rx_i,cts_i;
   output [1:0]  tx_o,rts_o;
   output 	 clk_o;
   wire 	 rst_o;
      
   output [7:0] dbg_o;

   reg [22:0] 	cnt;
   wire 	clk;
   assign 	clk = cnt[22];
   always @(posedge clk_i) cnt <= cnt + 1'b1;
   
   assign 	dbg_o = {add_o[9:2]};
         
   
   
   
   
   RAMB4_S8 rom0(
		 .WE(1'b0),
		 .EN(1'b1),
		 .RST(1'b0),
		 .CLK(clk_o),
		 .ADDR(add_o[10:2]),
		 .DO(p_dat_i[7:0])
		 );

   RAMB4_S8 rom1(
		 .WE(1'b0),
		 .EN(1'b1),
		 .RST(1'b0),
		 .CLK(clk_o),
		 .ADDR(add_o[10:2]),
		 .DO(p_dat_i[15:8])
		 );
   
   RAMB4_S8 rom2(
		 .WE(1'b0),
		 .EN(1'b1),
		 .RST(1'b0),
		 .CLK(clk_o),
		 .ADDR(add_o[10:2]),
		 .DO(p_dat_i[23:16])
		 );
   
   RAMB4_S8 rom3(
		 .WE(1'b0),
		 .EN(1'b1),
		 .RST(1'b0),
		 .CLK(clk_o),
		 .ADDR(add_o[10:2]),
		 .DO(p_dat_i[31:24])
		 );
     
   
   
   
   
   
   
   RAMB4_S8 ram0(
		 .WE(we_o),
		 .EN(1'b1),
		 .RST(rst_o),
		 .CLK(clk_o),
		 .ADDR(add_o[10:2]),
		 .DO(m_dat_i[7:0]),
		 .DI(dat_o[7:0])
		 );

   RAMB4_S8 ram1(
		 .WE(we_o),
		 .EN(1'b1),
		 .RST(rst_o),
		 .CLK(clk_o),
		 .ADDR(add_o[10:2]),
		 .DO(m_dat_i[15:8]),
		 .DI(dat_o[15:8])
		 );
   
   RAMB4_S8 ram2(
		 .WE(we_o),
		 .EN(1'b1),
		 .RST(rst_o),
		 .CLK(clk_o),
		 .ADDR(add_o[10:2]),
		 .DO(m_dat_i[23:16]),
		 .DI(dat_o[23:16])
		 );
   
   RAMB4_S8 ram3(
		 .WE(we_o),
		 .EN(1'b1),
		 .RST(rst_o),
		 .CLK(clk_o),
		 .ADDR(add_o[10:2]),
		 .DO(m_dat_i[31:24]),
		 .DI(dat_o[31:24])
		 );


   assign dat_i = (add_o[aw-1] == 1'b1) ? m_dat_i : p_dat_i;
   
   k68_soc soc0 (
		 .add_o(add_o),
		 .dat_o(dat_o),
		 .dat_i(dat_i),
		 .we_o(we_o),
		 .tx_o(tx_o),.rts_o(rts_o),
		 .rx_i(rx_i),.cts_i(cts_i),
		 .int_i(int_i),
		 .clk_o(clk_o), .rst_o(rst_o),
		 .clk_i(clk_i), .rst_i(rst_i)
		 );
      
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_arb.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_arb.v"
















module k68_arb (
   
   m_dat_o, m_we_o, m_cs_o, g_we_o, g_cs_o, a_we_o, a_cs_o, b_we_o, b_cs_o, 
   
   rst_i, m_add_i, m_we_i, m_dat_i, g_dat_i, a_dat_i, b_dat_i, arbclk
   ) ;
   parameter aw =  6'd32;
   parameter dw =  6'd32;
   parameter ow =  6'd16;
    
   
   
   input     rst_i;
        
   
   output [dw-1:0] m_dat_o;
   input [aw-1:0]  m_add_i;
   input 	   m_we_i;
   reg [dw-1:0]    m_dat_o;
   
   
   input [dw-1:0]  m_dat_i;
   output 	   m_we_o;
   output 	   m_cs_o;
   reg 		   m_we_o, m_cs_o;
   
   
   
   

   
   input [15:0]    g_dat_i;
   output 	   g_we_o, g_cs_o;
   reg 		   g_we_o, g_cs_o;
   
   
   input [9:0] 	   a_dat_i;
   output 	   a_we_o, a_cs_o;
   reg 		   a_we_o, a_cs_o;
   
   
   input [9:0] 	   b_dat_i;
   output 	   b_we_o, b_cs_o;
   reg 		   b_we_o, b_cs_o;
   
   input 	   arbclk;

   always @ (posedge arbclk) begin
    if (rst_i) begin
      
      
      a_cs_o = 0;
      a_we_o = 0;
      b_cs_o = 0;
      b_we_o = 0;
      g_cs_o = 0;
      g_we_o = 0;
      m_cs_o = 0;
      m_dat_o = 0;
      m_we_o = 0;
      
    end else begin 
       
       
       a_cs_o = 0;
       a_we_o = 0;
       b_cs_o = 0;
       b_we_o = 0;
       g_cs_o = 0;
       g_we_o = 0;
       m_cs_o = 0;
       m_dat_o = 0;
       m_we_o = 0;
       
       
      case (m_add_i[aw-1])
	1'b1:            
	  case (m_add_i[31:24])
	    8'hFF:
	      case (m_add_i[23:16])
		8'h00: begin 
		   g_cs_o = 1'b1;
		   g_we_o = m_we_i;
		   m_dat_o = g_dat_i;
		end

		8'h01: begin 
		   a_cs_o = 1'b1;
		   a_we_o = m_we_i;
		   m_dat_o = a_dat_i;
		end
		
		8'h02: begin 
		   b_cs_o = 1'b1;
		   b_we_o = m_we_i;
		   m_dat_o = b_dat_i;
		end

	       
		default: begin
		   
		   
		   a_cs_o = 0;
		   a_we_o = 0;
		   b_cs_o = 0;
		   b_we_o = 0;
		   g_cs_o = 0;
		   g_we_o = 0;
		   m_cs_o = 0;
		   m_dat_o = 0;
		   m_we_o = 0;
		   
		end
	      endcase 
	    default: begin
	       m_we_o = m_we_i;
	       m_cs_o = 1'b1;
	       m_dat_o = m_dat_i;
	    end
	  endcase 
	default:
	  case (m_add_i[1])
	    1'b1: begin
	       m_dat_o = {m_dat_i[31:16], m_dat_i[31:16]};
	       m_we_o = 1'b0;
	       m_cs_o = 1'b0;
	       a_cs_o = 1'b0;
	       b_cs_o = 1'b0;
	       g_cs_o = 1'b0;
	       
	    end
	    default: begin
	       m_dat_o = {m_dat_i[15:0], m_dat_i[15:0]};
	       m_we_o = 1'b0;
	       m_cs_o = 1'b0;
	       a_cs_o = 1'b0;
	       b_cs_o = 1'b0;
	       g_cs_o = 1'b0;
	       
	    end
	  endcase 
      endcase 
    end
   end
      
endmodule 



`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_asx.v"




































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 37 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_asx.v"





module k68_asx (
   
   res, 
   
   in, step
   ) ;
   parameter dw =  6'd32;
   
   output [dw-1:0] res;
   input [dw-1:0] in;
   input [5:0] 	  step;
   reg [dw-1:0] 	  res;
  
   always @ ( in or step) begin
      if (step[5])
	if (in[31])
	  case (step[4:0])
	    5'd01: res <= {1'b1,in[31:1]};
	    5'd02: res <= {2'b11,in[31:2]};
	    5'd03: res <= {3'b111,in[31:3]};
	    5'd04: res <= {4'b1111,in[31:4]};
	    5'd05: res <= {5'b11111,in[31:5]};
	    5'd06: res <= {6'b111111,in[31:6]};
	    5'd07: res <= {7'b1111111,in[31:7]};
	    5'd08: res <= {8'b11111111,in[31:8]};
	    5'd09: res <= {9'b111111111,in[31:9]};
	    5'd10: res <= {10'b1111111111,in[31:10]};
	    5'd11: res <= {11'b11111111111,in[31:11]};
	    5'd12: res <= {12'b111111111111,in[31:12]};
	    5'd13: res <= {13'b1111111111111,in[31:13]};
	    5'd14: res <= {14'b11111111111111,in[31:14]};
	    5'd15: res <= {15'b111111111111111,in[31:15]};
	    5'd16: res <= {16'b1111111111111111,in[31:16]};
	    5'd17: res <= {17'b11111111111111111,in[31:17]};
	    5'd18: res <= {18'b111111111111111111,in[31:18]};
	    5'd19: res <= {19'b1111111111111111111,in[31:19]};
	    5'd20: res <= {20'b11111111111111111111,in[31:20]};
	    5'd21: res <= {21'b111111111111111111111,in[31:21]};
	    5'd22: res <= {22'b1111111111111111111111,in[31:22]};
	    5'd23: res <= {23'b11111111111111111111111,in[31:23]};
	    5'd24: res <= {24'b111111111111111111111111,in[31:24]};
	    5'd25: res <= {25'b1111111111111111111111111,in[31:25]};
	    5'd26: res <= {26'b11111111111111111111111111,in[31:26]};
	    5'd27: res <= {27'b111111111111111111111111111,in[31:27]};
	    5'd28: res <= {28'b1111111111111111111111111111,in[31:28]};
	    5'd29: res <= {29'b11111111111111111111111111111,in[31:29]};
	    5'd30: res <= {30'b111111111111111111111111111111,in[31:30]};
	    5'd31: res <= {31'b1111111111111111111111111111111,in[31]};
	    default: res <= in;
	  endcase 
	else
	  res <= in >> step[4:0];
      else
	res <= in << step[4:0];
   end
   

endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_b2d.v"




































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 37 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_b2d.v"





module k68_b2d(
   
   d, 
   
   b
   );
   parameter dw =  6'd32;
   input [7:0] b;
   output [7:0] d;
   reg [7:0] 	d;

   always @ ( b) begin

      if (b[7:4] >= 4'd5)
	d[7:4] = b[7:4] - 2'd3;
      else
	d[7:4] = b[7:4];

      if (b[3:0] >= 4'd5)
	d[3:0] = b[3:0] - 2'd3;
      else
	d[3:0] = b[3:0];
            
   end
   
      
endmodule 
 

`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_buni.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_buni.v"





module k68_buni (
   
   cs_o, we_o, add_o, dat_o, p_dat_o, m_dat_o, 
   
   clk_i, rst_i, p_add_i, m_add_i, dat_i, m_dat_i, m_we_i
   ) ;
   parameter aw =  6'd32;
   parameter dw =  6'd32;
   parameter ow =  6'd16;
   parameter xxxx =  32'bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
   parameter zero =  32'd0;
   
   input     clk_i, rst_i;
   output    cs_o, we_o;
   
   input [aw-1:0] p_add_i, m_add_i;
   output [aw-1:0] add_o;

   input [dw-1:0]  dat_i;
   output [dw-1:0] dat_o;
       
   input [dw-1:0]  m_dat_i;
   output [ow-1:0]  p_dat_o;
   output [dw-1:0]  m_dat_o;

   input 	    m_we_i;
   reg [1:0] 	    uni_cnt;
 

   
   assign 	    cs_o = 1'b1;
   
   assign 	    m_dat_o = (uni_cnt == 2'b00) ? xxxx : dat_i;
   assign 	    p_dat_o = (uni_cnt == 2'b00) ? dat_i : xxxx;
   assign 	    add_o = (uni_cnt == 2'b00) ? p_add_i : m_add_i;
   assign 	    dat_o = m_dat_i;
   assign 	    we_o = (uni_cnt == 2'b00) ? 1'b0 : m_we_i;
   
   
   
   always @(posedge clk_i) begin
      if (rst_i)
	uni_cnt <= 2'b00;
      else
	uni_cnt <= uni_cnt + 2'b01;
   end
      
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_calc.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_calc.v"






module k68_calc (
   
   ea_o, rs_add_o, rt_add_o, rd_add_o, rd_dat_o, r_we_o, dat_o, skip_o, 
   
   rst_i, we_i, add_i, dst_i, imm_i, dat_i, rs_dat_i, rt_dat_i, siz_i, pc_i
   ) ;

   parameter kw=6;
   parameter aw =  6'd32;
   parameter gw =  6'd4;
   parameter dw =  6'd32;
   parameter xxxx =  32'bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
            
   input     rst_i, we_i;
   input [kw-1:0] add_i,dst_i;
   output [aw-1:0] ea_o;
   input [dw-1:0]  imm_i, dat_i;
   output [gw-1:0] rs_add_o, rt_add_o, rd_add_o;
   input [dw-1:0]  rs_dat_i, rt_dat_i;
   output [dw-1:0] rd_dat_o;
   output 	   r_we_o;
   output [dw-1:0] dat_o;
   input [1:0] 	   siz_i;
   output [1:0]    skip_o;
   input [aw-1:0]  pc_i;
   
   reg [aw-1:0]    ea_o;
   reg [gw-1:0]    rs_add_o, rt_add_o, rd_add_o;
   reg [dw-1:0]    rd_dat_o;
   reg 		   r_we_o;
   reg [1:0] 	   skip_o;
   reg [dw-1:0]    dat_o;
   
   always @ ( add_i or imm_i or rst_i or siz_i or we_i) begin
      if (rst_i) begin
	 
	 
	 r_we_o = 0;
	 rd_add_o = 0;
	 rs_add_o = 0;
	 rt_add_o = 0;
	 skip_o = 0;
	 
      end else begin 

	 
	 
	 r_we_o = 0;
	 rd_add_o = 0;
	 rs_add_o = 0;
	 rt_add_o = 0;
	 skip_o = 0;
	 
	 
	 
	 
	 r_we_o = 1'b0;

	      case (add_i[5:3])
		3'h0,3'h1: begin 
		   rt_add_o = add_i[3:0];
		   rd_add_o = add_i[3:0];
		   r_we_o = we_i;
		end
		3'h2: begin 
		   rt_add_o = {1'b1, add_i[2:0]};
		end
		3'h3: begin 
		   rt_add_o = {1'b1, add_i[2:0]};
		   rd_add_o = {1'b1, add_i[2:0]};
		   r_we_o = ~we_i;
		end 
		3'h4: begin 
		   rt_add_o = {1'b1, add_i[2:0]};
		   rd_add_o = {1'b1, add_i[2:0]};
		   r_we_o = we_i;
		end 
		3'h5: begin 
		   rt_add_o = {1'b1, add_i[2:0]};
		   skip_o = 2'd1;
		end
		3'h6: begin 
		   rt_add_o = {1'b1, add_i[2:0]};
		   rs_add_o = {imm_i[31:28]};
		   skip_o = 2'd1;
		end
		default:
		  case (add_i[2:0])
		    3'h0: begin 
		       skip_o = 2'd1;
		    end
		    3'h1: begin 
		       skip_o = 2'd2;
		    end
		    3'h2: begin 
		       skip_o = 2'd1;
		    end
		    3'h3: begin 
		       rs_add_o = {imm_i[31:28]};
		       skip_o = 2'd1;
		    end
		    3'h4: begin 
		       case (siz_i)
			 2'b10,2'b11: begin
			    skip_o = 2'b10;
			 end
			 
			 default: begin
			    skip_o = 2'b01;
			 end
			 
		       endcase 
		    end 
		    3'h5: begin
		       skip_o = 2'd0;
		    end
		    3'h7: begin
		       skip_o = 2'd0;
		    end
		    default: begin
		       skip_o = xxxx;
		    end
		    
		  endcase 
	      endcase 
	 
      end 
   end 
     
   always @ ( add_i or dat_i or imm_i or pc_i or rs_dat_i or rst_i or rt_dat_i or siz_i) begin
      if (rst_i) begin
	 
	 
	 dat_o = 0;
	 ea_o = 0;
	 rd_dat_o = 0;
	 
      end else begin 
	 
	 
	 dat_o = 0;
	 ea_o = 0;
	 rd_dat_o = 0;
	 
	      case (add_i[5:3])
		3'h0,3'h1: begin 
		   dat_o = rt_dat_i;
		   rd_dat_o = dat_i;
		end
		3'h2: begin 
		   ea_o = rt_dat_i;
		   dat_o = dat_i;
		end
		3'h3: begin 
		   ea_o = rt_dat_i;
		   dat_o = dat_i;
		   rd_dat_o = rt_dat_i + 3'd4;
		end 
		3'h4: begin 
		   ea_o = rt_dat_i - 3'd4;
		   rd_dat_o = rt_dat_i - 3'd4;
		   dat_o = dat_i;
		end 
		3'h5: begin 
		   ea_o = rt_dat_i + {{16{imm_i[31]}},imm_i[31:16]};
		   dat_o = dat_i;
		end
		3'h6: begin 
		   ea_o = rt_dat_i + {{24{imm_i[31]}},imm_i[23:16]} + (rs_dat_i << imm_i[26:25]);
		   dat_o = dat_i;
		end
		default:
		  case (add_i[2:0])
		    3'h0: begin 
		       ea_o = {{16{imm_i[31]}},imm_i[31:16]};
		       dat_o = dat_i;
		    end
		    3'h1: begin 
		       ea_o = imm_i;
		       dat_o = dat_i;
		    end
		    3'h2: begin 
		       ea_o = pc_i + {{16{imm_i[31]}},imm_i[31:16]};
		       dat_o = dat_i;
		    end
		    3'h3: begin 
		       ea_o = pc_i + {{24{imm_i[31]}},imm_i[23:16]} + (rs_dat_i << imm_i[26:25]);
		       dat_o = dat_i;
		    end
		    3'h4: begin 
		       case (siz_i)
			 2'b10,2'b11: begin
			    dat_o = imm_i;
			 end
			 
			 default: begin
			    dat_o = {16'd0,imm_i[31:16]};
			 end
			 
		       endcase 
		    end 
		    3'h5: begin
		       dat_o = pc_i;
		       ea_o = xxxx;
		    end
		    3'h7: begin
		       dat_o = 32'd0;
		       ea_o = xxxx;
		    end
		    default: begin
		       ea_o = xxxx;
		       dat_o = xxxx;
		    end
		  endcase 
	      endcase 
      end 
   end 
     
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_ccc.v"




































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 37 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_ccc.v"





module k68_ccc(
   
   flag, 
   
   cc, code
   );

   parameter XF =  3'd4;
   parameter CF =  3'd0;
   parameter NF =  3'd3;
   parameter ZF =  3'd2;
   parameter VF =  3'd1;
      
   input [7:0] cc;
   input [3:0] code;
   output      flag;
   reg 	       flag;

   always @(cc or code) begin
      case (code)
	4'h4: flag = ~cc[CF];
	4'h5: flag = cc[CF];
	4'h7: flag = cc[ZF];
	4'hC: flag = cc[NF] & cc[VF] | ~cc[NF] & ~cc[VF];
	4'hE: flag = cc[NF] & cc[VF] & ~cc[ZF] | ~cc[NF] & ~cc[VF] & ~cc[ZF];
	4'h2: flag = ~cc[CF] & ~cc[ZF];
	4'hF: flag = cc[ZF] | cc[NF] & ~cc[VF] | ~cc[NF] & cc[VF];
	4'h3: flag = cc[CF] | cc[ZF];
	4'hD: flag = cc[NF] & ~cc[VF] | ~cc[NF] & cc[VF];
	4'hB: flag = cc[NF];
	4'h6: flag = ~cc[ZF];
	4'hA: flag = ~cc[NF];
	4'h8: flag = ~cc[VF];
	4'h9: flag = cc[VF];
	4'h1: flag = 1'b0;
	4'h0: flag = 1'b1;
	
      endcase 
   end
   
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_clkgen.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_clkgen.v"






module k68_clkgen (
   
   clk4_o, clk_o, rst_o, 
   
   clk_i, rst_i
   ) ;

   input clk_i,rst_i;
   output clk4_o;
   output clk_o;
   output rst_o;
   reg 	  rst_o;
   
   reg [1:0] 	    cnt;

   assign    clk4_o = cnt[1];
   assign    clk_o = ~clk_i;
   
   initial cnt = 0;	

   always @(posedge clk_i) begin
	cnt <= cnt + 1'b1;
   end

   always @(posedge clk4_o) rst_o <= rst_i;
      
endmodule 



`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_cpu.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_cpu.v"


module k68_cpu (
   
   add_o, cs_o, dat_o, we_o, clk_o, rst_o, 
   
   dat_i, clk_i, rst_i, int_i
   );
   parameter dw =  6'd32;
   parameter aw =  6'd32;
   parameter ow =  6'd16;
   parameter gw =  6'd4;
   parameter sw =  6'd8;
   parameter lw =  3'd6;
   parameter kw = 6;
            
   output [aw-1:0] add_o;
   output 	   cs_o;
   output [dw-1:0] dat_o;
   input [dw-1:0]  dat_i;
   output 	   we_o;
   input 	   clk_i,rst_i;
   input [2:0] 	   int_i;
   output 	   clk_o;
   output 	   rst_o;
         
   wire [aw-1:0]   p_add_o, m_add_o;
   wire 	   p_cs_o, m_cs_o, m_we_o;
   wire [dw-1:0]   m_dat_i, m_dat_o;
   wire [ow-1:0]   p_dat_i;
   
   wire 	   f_rdy_o;
   wire [aw-1:0]   f_pc_o;
   wire [ow-1:0]   f_op_o;
   wire [dw-1:0]   f_imm_o;
   
   wire [lw-1:0]   d_alu_o;
   wire [dw-1:0]   d_src_o, d_dst_o;
   wire 	   d_run_o,d_brch_o;
   wire [1:0] 	   d_skip_o;
   wire [aw-1:0]   d_pc_o;
   wire [kw-1:0]   d_add_a_o, d_add_b_o, d_add_c_o, d_add_src_o, d_add_dst_o;
   wire [dw-1:0]   d_dat_c_o;
   wire [1:0] 	   d_siz_o, d_siz_a_o;
   wire [dw-1:0]   d_imm_o;
   
   wire [dw-1:0]   a_dat_a_o, a_dat_b_o, a_dat_c_o;
   wire [1:0] 	   a_skip_o;
   wire [gw-1:0]   a_rs_add_o, a_rt_add_o, a_rd_add_o;
   wire 	   a_we_o;
   wire [dw-1:0]   a_rd_dat_o;
   wire [dw-1:0]   a_dst_o;
   
   wire [aw-1:0]   e_pc_o, d_alu_pc_o;
   
   wire [dw-1:0]   r_rs_dat_o, r_rt_dat_o;
   
   wire [dw-1:0]   e_res_o;
   wire [sw-1:0]   e_ccr_o, e_ssr_o;
   wire [kw-1:0]   e_add_c_o;
   wire [lw-1:0]   e_alu_o;
   
   wire 	   clk4_i;
   wire [1:0] 	   e_siz_o, c_siz_o;
      
   wire 	   rst,cs,we;
  



   assign 	   rst = ~rst_i;

  

   assign 	   cs_o = cs;
   assign 	   we_o = we;





   
   
   
   
   k68_clkgen clkgen0(.clk4_o(clk4_i), .rst_o(rst_o), .clk_o(clk_o),
		      .clk_i(clk_i), .rst_i(rst)
		      );

   k68_buni unify0(
		   .add_o(add_o),
		   .dat_o(dat_o),
		   .dat_i(dat_i),
		   
		   .cs_o(cs),
		   .we_o(we),

		   .p_add_i(p_add_o),
		   .p_dat_o(p_dat_i),

		   .m_add_i(m_add_o),
		   .m_we_i(m_we_o),
		   .m_dat_i(m_dat_o),
		   .m_dat_o(m_dat_i),
		   
		   .clk_i(clk_i), .rst_i(rst_o)
		   );
  
   k68_fetch fetch0 (
		     .rst_i(rst_o),
		     .cpu_clk_i(clk4_i), 
		     .mem_clk_i(clk_i),
		     .p_add_o(p_add_o),
		     .p_dat_i(p_dat_i),
		     .p_cs_o(p_cs_o),
		     .pc_o(f_pc_o),
		     .brch_i(d_brch_o),
		     .op_o(f_op_o),
		     .imm_o(f_imm_o),
		     .pc_i(d_pc_o)
		     );
  
   k68_load addmode0(
		     .dat_a_o(a_dat_a_o),
		     .dat_b_o(a_dat_b_o),
		     .dat_c_o(a_dat_c_o),
		     .skip_o(a_skip_o),
		     .m_add_o(m_add_o),
		     .m_dat_o(m_dat_o),
		     .m_cs_o(m_cs_o),
		     .m_we_o(m_we_o),
		     .rs_add_o(a_rs_add_o),
		     .rt_add_o(a_rt_add_o),
		     .rd_add_o(a_rd_add_o),
		     .r_we_o(a_we_o),
		     .rd_dat_o(a_rd_dat_o),
		     
		     .dat_c_i(d_dat_c_o),
		     .add_a_i(d_add_a_o),
		     .add_b_i(d_add_b_o),
		     .add_c_i(d_add_c_o),
		     .imm_i(d_imm_o),
		     .siz_i(d_siz_a_o),
		     .m_dat_i(m_dat_i),
		     .rs_dat_i(r_rs_dat_o),
		     .rt_dat_i(r_rt_dat_o),
		     .c_siz_i(c_siz_o),
		     .pc_i(f_pc_o),

		     .clk_i(clk4_i),
		     .m_clk_i(clk_i),.rst_i(rst_o)
		     );
      
   k68_execute execute0(
			.res_o(e_res_o),
			.ccr_o(e_ccr_o),
			.ssr_o(e_ssr_o),
			.alu_o(e_alu_o),
			.add_c_o(e_add_c_o),
			.pc_i(d_alu_pc_o),
			.pc_o(e_pc_o),
			.siz_o(e_siz_o),
			.int_i(int_i),
			
			.alu_i(d_alu_o),
			.src_i(d_src_o),
			.dst_i(d_dst_o),
			.add_src_i(d_add_src_o),
			.add_dst_i(d_add_dst_o),
			.siz_i(d_siz_o),

			.skip_i(a_skip_o),
			.clk_i(clk4_i), .rst_i(rst_o)
			);
 
   k68_regbank regbank0(
			.rs_dat_o(r_rs_dat_o),
			.rt_dat_o(r_rt_dat_o),

			.rs_add_i(a_rs_add_o),
			.rt_add_i(a_rt_add_o),
			.rd_add_i(a_rd_add_o),
			.we_i(a_we_o),
			.rd_dat_i(a_rd_dat_o),
			.clk_i(clk_i), .rst_i(rst_o)
			);
   
   k68_decode decode0 (
		       .pc_i(f_pc_o),
		       .op_i(f_op_o),
		       .imm_i(f_imm_o),
		       .alu_i(e_alu_o),
		       .res_i(e_res_o),
		       .add_c_i(e_add_c_o),
		       .dat_a_i(a_dat_a_o),
		       .dat_b_i(a_dat_b_o),
		       .skip_i(a_skip_o),
		       .alu_pc_i(e_pc_o),
		       .dat_c_i(a_dat_c_o),
		       
		       .siz_i(e_siz_o),
		       .c_siz_o(c_siz_o),
		       
		       .alu_o(d_alu_o),
		       .src_o(d_src_o),
		       .dst_o(d_dst_o),
		       .skip_o(d_skip_o),
		       .brch_o(d_brch_o),
		       .pc_o(d_pc_o),
		       .alu_pc_o(d_alu_pc_o),
		       
		       .add_a_o(d_add_a_o),
		       .add_b_o(d_add_b_o),
		       .add_c_o(d_add_c_o),
		       .add_src_o(d_add_src_o),
		       .add_dst_o(d_add_dst_o),
		       .dat_c_o(d_dat_c_o),
		       .siz_o(d_siz_o),
		       .imm_o(d_imm_o),
		       .siz_a_o(d_siz_a_o),
		       
		       .clk_i(clk4_i),
		       .rst_i(rst_o)
		       );

endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_d2b.v"




































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 37 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_d2b.v"





module k68_d2b(
   
   b, 
   
   d
   );
   parameter dw =  6'd32;
   input [7:0] d;
   output [7:0] b;
   reg [7:0] 	b;

   always @ ( d) begin

      if (d[7:4] >= 4'd5)
	b[7:4] = d[7:4] + 2'd3;
      else
	b[7:4] = d[7:4];

      if (d[3:0] >= 4'd5)
	b[3:0] = d[3:0] + 2'd3;
      else
	b[3:0] = d[3:0];
            
   end
     
   
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_decode.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_decode.v"


module k68_decode (
   
   alu_o, src_o, dst_o, skip_o, brch_o, pc_o, alu_pc_o, c_siz_o, 
   imm_o, add_a_o, add_b_o, add_c_o, add_src_o, add_dst_o, dat_c_o, 
   siz_o, siz_a_o, 
   
   clk_i, rst_i, pc_i, op_i, imm_i, alu_i, res_i, alu_pc_i, siz_i, 
   add_c_i, dat_a_i, dat_b_i, dat_c_i, skip_i
   ) ;
   
   parameter dw= 6'd32;
   parameter aw= 6'd32;
   parameter nop =  16'b0100111001110001;
   parameter zero=  32'd0;
   parameter xxxx=  32'bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
   parameter ow =  6'd16;
   parameter lw =  3'd6;
   parameter sw =  6'd8;
   parameter gw =  6'd4;
   parameter kw = 6;
   parameter esc =  6'h3F;
   parameter reset =  32'h00000000;
            
   
   parameter zf =  3'd2;
   parameter cf =  3'd0;
   parameter vf =  3'd1;
   parameter nf =  3'd3;
   parameter xf =  3'd4;
   
   
   parameter ALU_ABCD =  6'h0D;
   parameter ALU_SBCD =  6'h0A;
   parameter ALU_NBCD =  6'h11;
   parameter ALU_ADD =  6'h0B;
   parameter ALU_ADDX =  6'h0C;
   parameter ALU_SUB =  6'h08;
   parameter ALU_SUBX =  6'h09;
   parameter ALU_OR =  6'h04;
   parameter ALU_AND =  6'h05;
   parameter ALU_EOR =  6'h06;
   parameter ALU_BTST =  6'h18;
   parameter ALU_BCHG =  6'h19;
   parameter ALU_BCLR =  6'h1A;
   parameter ALU_BSET =  6'h1B;
   parameter ALU_MOV =  6'h3F;
   parameter ALU_DIV =  6'h0F;
   parameter ALU_MUL =  6'h0E;
   parameter ALU_ASX =  6'h1C;
   parameter ALU_LSX =  6'h1D;
   parameter ALU_ROX =  6'h1F;
   parameter ALU_ROXX =  6'h1E;
   parameter ALU_NOT =  6'h07;
   parameter ALU_NOP =  6'h00;
   parameter ALU_NEGX =  6'h12;
   parameter ALU_NEG =  6'h10;
   
   parameter ALU_MOVSR =  6'h14;
   parameter ALU_ANDSR =  6'h02;
   parameter ALU_ORSR =  6'h01;
   parameter ALU_EORSR =  6'h03;

   parameter ALU_BCC =  6'h15;
   parameter ALU_DBCC =  6'h16;
   parameter ALU_SCC =  6'h17;
   parameter ALU_SWAP =  6'h20;
   parameter ALU_STOP =  6'h21;

   parameter ALU_VECTOR =  6'h22;
   parameter ALU_TAS =  6'h23;
   parameter ALU_TST =  6'h24;
   parameter ALU_EA =  6'h25;
   parameter ALU_CMP =  6'h13;
   
   
   input     clk_i,rst_i;
   input [aw-1:0] pc_i;     
   input [ow-1:0] op_i;     
   input [dw-1:0] imm_i;    
   input [lw-1:0] alu_i;    
   output [lw-1:0] alu_o;   
   output [dw-1:0] src_o, dst_o; 
   input [dw-1:0]  res_i;   
   output [1:0]    skip_o;  
   output          brch_o;  
   output [aw-1:0] pc_o;    
   input [aw-1:0]  alu_pc_i;
   output [aw-1:0] alu_pc_o;
   input [1:0] 	   siz_i;
   output [1:0]    c_siz_o;
   reg [1:0] 	   c_siz_o;
   output [dw-1:0] imm_o;
      
   output [kw-1:0]    add_a_o, add_b_o, add_c_o, add_src_o, add_dst_o; 
   input [kw-1:0]     add_c_i;
   input [dw-1:0]  dat_a_i, dat_b_i, dat_c_i;
   output [dw-1:0] dat_c_o;
   output [1:0]    siz_o,siz_a_o;
   input [1:0] 	   skip_i;
 
   reg [ow-1:0]    op;
   reg [lw-1:0]    alu_o;
   reg [dw-1:0]    src_o;
   reg [aw-1:0]    pc_o, alu_pc_o;
   reg 		   brch_o;
   reg [1:0] 	   skip_o, skip;
   reg [kw-1:0]    add_src_o, add_dst_o, add_a_o, add_b_o, add_c_o;
   reg [1:0] 	   siz_o, siz_a_o;
   reg [dw-1:0]	   dat_c_o;
   reg [dw-1:0]    imm_o;

   reg [dw-1:0]    src,dst_o;
   reg [lw-1:0]    alu;
   reg [1:0] 	   siz;
   reg [kw-1:0]    add_src, add_dst;
   reg 		   brch;

   
      
   
   
   
   
   
   always @ (posedge clk_i) begin
      
      if (rst_i || skip[0] || skip[1] || brch_o) begin
	 
	 
	 add_dst_o <= 0;
	 add_src_o <= 0;
	 alu_o <= 0;
	 alu_pc_o <= 0;
	 brch <= 0;
	 dst_o <= 0;
	 siz_o <= 0;
	 skip <= 0;
	 skip_o <= 0;
	 src_o <= 0;
	 
	 
	 add_src_o <= esc;
	 add_dst_o <= esc;
	 skip <= skip_i;
	 brch <= brch_o;
	 
      end else begin 
	 
	 brch <= brch_o;
	 skip <= skip_i;
	 src_o <= src;
	 dst_o <= dat_b_i;
	 alu_o <= alu;
	 siz_o <= siz;
	 skip_o <= skip_i;
	 add_src_o <= add_src;
	 add_dst_o <= add_dst;
	 alu_pc_o <= pc_i;
	 
      end 
      
   end 
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   
   always @(dat_a_i or dat_c_i or imm_i or op or op_i
	    or rst_i or skip) begin
      if (rst_i || skip[1] || skip[0]) begin
	 
	 
	 add_a_o = 0;
	 add_b_o = 0;
	 add_dst = 0;
	 add_src = 0;
	 alu = 0;
	 imm_o = 0;
	 siz = 0;
	 siz_a_o = 0;
	 src = 0;
	 
	 add_a_o = esc;
	 add_b_o = esc;

      end else begin 
	 
	 add_a_o = esc;
	 add_b_o = esc;
	 imm_o = imm_i;
	 siz_a_o = 2'd0;
	 alu = 6'd0;
	 src = zero;
	 
	 add_src = esc;
	 add_dst = esc;
	 siz = 2'b11;
	 	 	 
      case (op_i[15:12])

	
	
	4'h0: begin 
	  case (op_i[11:8])
	    4'h0: begin 
	       case (op_i[7:0])
		 8'h3C: begin 
		    alu = ALU_ORSR;
		    siz_a_o = 2'b01;
		    add_a_o = 6'h3C;
		    add_b_o = esc;

		    src = {24'd0,dat_a_i[7:0]};
		    
		    add_src = 6'h3C;
		    add_dst = 6'h3C;
		    siz = 2'b01;
		    
		 end 
		 8'h7C: begin 
		    alu = ALU_ORSR;
		    siz_a_o = 2'b01;
		    add_a_o = 6'h3C;
		    add_b_o = esc;

		    src = {16'd0,dat_a_i[15:0]};
		    
		    add_src = 6'h3C;
		    add_dst = 6'h3C;
		    siz = 2'b01;
		 end 
		 default: begin 
		    alu = ALU_OR;
		    siz_a_o = op_i[7:6];
		    add_a_o = 6'h3C;
		    add_b_o = op_i[5:0];

		    src = dat_a_i;
		    
		    add_src = 6'h3C;
		    add_dst = op_i[5:0];
		    siz = op_i[7:6];
		 end 
	       endcase 
	    end 
	    4'h2: begin 
	       case (op_i[7:0])
		 8'h3C: begin 
		    alu = ALU_ANDSR;
		    siz_a_o = 2'b01;
		    add_a_o = 6'h3C;
		    add_b_o = esc;

		    src = {24'hFFFFFF,dat_a_i[7:0]};
		    
		    add_src = 6'h3C;
		    add_dst = 6'h3C;
		    siz = 2'b01;
		 end 
		 8'h7C: begin 
		    alu = ALU_ANDSR;
		    siz_a_o = 2'b01;
		    add_a_o = 6'h3C;
		    add_b_o = esc;

		    src = {16'hFFFF,dat_a_i[15:0]};
		    
		    add_src = 6'h3C;
		    add_dst = 6'h3C;
		    siz = 2'b01;
		 end 
		 default: begin 
		    alu = ALU_AND;
		    siz_a_o = op_i[7:6];
		    add_a_o = 6'h3C;
		    add_b_o = op_i[5:0];

		    src = dat_a_i;
		    
		    add_src = 6'h3C;
		    add_dst = op_i[5:0];
		    siz = op_i[7:6];
		 end 
	       endcase 
	    end 
	    4'h4: begin 
	       alu = ALU_SUB;
	       siz_a_o = op_i[7:6];
	       add_a_o = 6'h3C;
	       add_b_o = op_i[5:0];
	       
	       src = dat_a_i;
	       
	       add_src = 6'h3C;
	       add_dst = op_i[5:0];
	       siz = op_i[7:6];
	       
	    end 
	    4'h6: begin 
	       alu = ALU_ADD;
	       siz_a_o = op_i[7:6];
	       add_a_o = 6'h3C;
	       add_b_o = op_i[5:0];
	       
	       src = dat_a_i;
	       
	       add_src = 6'h3C;
	       add_dst = op_i[5:0];
	       siz = op_i[7:6];
	       
	    end 
	    4'hA: begin 
	       case (op_i[7:0])
		 8'h3C: begin 
		    alu = ALU_EORSR;
		    siz_a_o = 2'b01;
		    add_a_o = 6'h3C;
		    add_b_o = esc;

		    src = {24'd0,dat_a_i[7:0]};
		    
		    add_src = 6'h3C;
		    add_dst = 6'h3C;
		    siz = 2'b01;
		 end 
		 8'h7C: begin 
		    alu = ALU_EORSR;
		    siz_a_o = 2'b01;
		    add_a_o = 6'h3C;
		    add_b_o = esc;

		    src = {16'd0,dat_a_i[15:0]};
		    
		    add_src = 6'h3C;
		    add_dst = 6'h3C;
		    siz = 2'b01;
		 end 
		 default: begin 
		    alu = ALU_EOR;
		    siz_a_o = op_i[7:6];
		    add_a_o = 6'h3C;
		    add_b_o = op_i[5:0];

		    src = dat_a_i;
		    
		    add_src = 6'h3C;
		    add_dst = op_i[5:0];
		    siz = op_i[7:6];

		 end 
	       endcase 
	    end 
	    4'hC: begin 
	       alu = ALU_SUB;
	       siz_a_o = op_i[7:6];
	       add_a_o = 6'h3C;
	       add_b_o = op_i[5:0];
	       
	       src = dat_a_i;
	       
	       add_src = 6'h3C;
	       add_dst = 6'h3C;
	       siz = op_i[7:6];

	    end 
	    4'h8: begin 
	       case (op_i[7:6])
		 2'b00: begin 
		    alu = ALU_BTST;
		    if (op_i[5:3]==3'b000) 
		      siz_a_o = 2'b10;
		    else
		      siz_a_o = 2'b00;

		    add_a_o = 6'h3C;
		    add_b_o = op_i[5:0];

		    src = dat_a_i;
		    
		    add_src = 6'h3C;
		    add_dst = op_i[5:0];
		    
		    siz = 2'b10;	        
		 end 
		 2'b01: begin 
		    alu = ALU_BCHG;
		    if (op_i[5:3]==3'b000) 
		      siz_a_o = 2'b10;
		    else
		      siz_a_o = 2'b00;

		    add_a_o = 6'h3C;
		    add_b_o = op_i[5:0];

		    src = dat_a_i;
		    
		    add_src = 6'h3C;
		    add_dst = op_i[5:0];
		    
		    siz = 2'b10;	        
		 end 
		 2'b10: begin 
		    alu = ALU_BCLR;
		    if (op_i[5:3]==3'b000) 
		      siz_a_o = 2'b10;
		    else
		      siz_a_o = 2'b00;

		    add_a_o = 6'h3C;
		    add_b_o = op_i[5:0];

		    src = dat_a_i;
		    
		    add_src = 6'h3C;
		    add_dst = op_i[5:0];
		    
		    siz = 2'b10;	        
		 end 
		 2'b11: begin 
		    alu = ALU_BSET;
		    if (op_i[5:3]==3'b000) 
		      siz_a_o = 2'b10;
		    else
		      siz_a_o = 2'b00;

		    add_a_o = 6'h3C;
		    add_b_o = op_i[5:0];

		    src = dat_a_i;
		    
		    add_src = 6'h3C;
		    add_dst = op_i[5:0];
		    
		    siz = 2'b10;	        
		 end 
	       endcase 
	    end 
	    default: begin 
	       case (op_i[5:3])
		 3'b001: begin 
		 end
		 default: begin
		    case (op_i[7:6])
		      2'b00: begin 
			 alu = ALU_BTST;
			 if (op_i[5:3]==3'b000) 
			   siz_a_o = 2'b10;
			 else
			   siz_a_o = 2'b00;
			 
			 add_a_o = {3'd0,op_i[11:9]};
			 add_b_o = op_i[5:0];
			 
			 src = dat_a_i;
			 
			 add_src = 6'h3C;
			 add_dst = op_i[5:0];
			 
			 siz = 2'b10;	        
			 
		      end 
		      2'b01: begin 
			 alu = ALU_BCHG;
			 if (op_i[5:3]==3'b000) 
			   siz_a_o = 2'b10;
			 else
			   siz_a_o = 2'b00;
			 
			 add_a_o = {3'd0,op_i[11:9]};
			 add_b_o = op_i[5:0];
			 
			 src = dat_a_i;
			 
			 add_src = 6'h3C;
			 add_dst = op_i[5:0];
			 
			 siz = 2'b10;	        
		      end 
		      2'b10: begin 
			 alu = ALU_BCLR;
			 if (op_i[5:3]==3'b000) 
			   siz_a_o = 2'b10;
			 else
			   siz_a_o = 2'b00;
			 
			 add_a_o = {3'd0,op_i[11:9]};
			 add_b_o = op_i[5:0];
			 
			 src = dat_a_i;
			 
			 add_src = 6'h3C;
			 add_dst = op_i[5:0];
			 
			 siz = 2'b10;	        
		      end 
		      2'b11: begin 
			 alu = ALU_BSET;
			 if (op_i[5:3]==3'b000) 
			   siz_a_o = 2'b10;
			 else
			   siz_a_o = 2'b00;
			 
			 add_a_o = {3'd0,op_i[11:9]};
			 add_b_o = op_i[5:0];
			 
			 src = dat_a_i;
			 
			 add_src = 6'h3C;
			 add_dst = op_i[5:0];
			 
			 siz = 2'b10;	        
		      end 
		    endcase 
		 end 
	       endcase 
	    end 
	  endcase 
	end 

	
	
	4'h1,4'h2,4'h3: begin 

	   alu = ALU_MOV;
	   
	   add_a_o = op_i[5:0];
	   add_b_o = {op_i[8:6], op_i[11:9]};

	   add_src = op_i[5:0];
	   add_dst = {op_i[8:6], op_i[11:9]};
	   src = dat_a_i;
	   

	   case (op_i[13:12])
	     2'b11: siz = 2'b01;
	     2'b01: siz = 2'b00;
	     default: siz = 2'b10;
	   endcase 
	   	 
	   case (op_i[13:12])
	     2'b11: siz_a_o = 2'b01;
	     2'b01: siz_a_o = 2'b00;
	     default: siz_a_o = 2'b10;
	   endcase 
	   	   
	end 

	

	4'h4: begin 
	   case (op_i[11:6])
	     6'h03: begin 
		alu = ALU_MOVSR;
		siz_a_o = 2'b01;
		add_a_o = esc;
		add_b_o = op_i[5:0];

		src = zero;
		
		add_src = esc;
		add_dst = op_i[5:0];
		siz = 2'b01;
		
	     end 
	     6'h0B: begin 
		
		
		
		alu = ALU_NOP;
		
		src = xxxx;
		add_dst = 6'bxxxxxx;
		add_src = 6'bxxxxxx;
		siz = 2'bxx;
		add_a_o = 6'bxxxxxx;
		add_b_o = 6'bxxxxxx;
		siz_a_o = 2'bxx;
	     end
	     6'h00,6'h01,6'h02: begin 
		alu = ALU_NEGX;
		siz_a_o = op_i[7:6];
		add_a_o = esc;
		add_b_o = op_i[5:0];

		src = zero;
		
		add_dst = op_i[5:0];
		add_src = esc;
		siz = op_i[7:6];
		
	     end 
	     6'h08,6'h09,6'h0A: begin 
		alu = ALU_MOV ;
		siz_a_o = op_i[7:6];
		add_a_o = esc;
		add_b_o = op_i[5:0];

		src = zero;
		
		add_dst = op_i[5:0];
		add_src = esc;
		siz = op_i[7:6];
		
	     end 
	     6'h13: begin 
		alu = ALU_MOVSR;
		siz_a_o = 2'b01;
		add_a_o = 6'h3C;
		add_b_o = esc;
		
		src = {24'd0,dat_a_i[7:0]};
		
		add_src = 6'h3C;
		add_dst = 6'h3C;
		siz = 2'b01;

	     end 
	     6'h10,6'h11,6'h12: begin 
		alu = ALU_NEG;
		siz_a_o = op_i[7:6];
		add_a_o = esc;
		add_b_o = op_i[5:0];

		src = zero;
		
		add_dst = op_i[5:0];
		add_src = esc;
		siz = op_i[7:6];
		
	     end 
	     6'h18,6'h19,6'h1A: begin 
		alu = ALU_NOT;
		siz_a_o = op_i[7:6];
		add_a_o = esc;
		add_b_o = op_i[5:0];

		src = zero;
		
		add_dst = op_i[5:0];
		add_src = esc;
		siz = op_i[7:6];
		
	     end 
	     6'h1B: begin 
		alu = ALU_MOVSR;
		siz_a_o = 2'b01;
		add_a_o = 6'h3C;
		add_b_o = esc;
		
		src = {24'd0,dat_a_i[7:0]};
		
		add_src = 6'h3C;
		add_dst = 6'h3C;
		siz = 2'b01;
	     end 
	     6'h22,6'h23: begin
		case (op_i[5:3])
		  3'b000: begin 
		     
		     
		     
		     alu = ALU_NOP;
		     
		     src = xxxx;
		     add_dst = 6'bxxxxxx;
		     add_src = 6'bxxxxxx;
		     siz = 2'bxx;
		     add_a_o = 6'bxxxxxx;
		     add_b_o = 6'bxxxxxx;
		     siz_a_o = 2'bxx;
		  end
		  default: begin 
		     
		     
		     
		     alu = ALU_NOP;
		     
		     src = xxxx;
		     add_dst = 6'bxxxxxx;
		     add_src = 6'bxxxxxx;
		     siz = 2'bxx;
		     add_a_o = 6'bxxxxxx;
		     add_b_o = 6'bxxxxxx;
		     siz_a_o = 2'bxx;
		  end
		endcase 
	     end
	     6'h21: begin
		case (op_i[5:3])
		  3'b000: begin 
		     alu = ALU_SWAP;
		     siz_a_o = 2'b10;
		     add_a_o = esc;
		     add_b_o = {3'd0, op_i[2:0]};

		     src = zero;
		     
		     add_src = 6'h3C;
		     add_dst = {3'd0, op_i[2:0]};
		     siz = 2'b10;
		  end 
		  3'b001: begin 
		     
		     add_a_o = esc;
		     add_b_o = esc;
		     siz_a_o = 2'b00;
		     
		     alu = ALU_VECTOR;
		     src = 6'd4;
		     
		     add_dst = 6'h3C;
		     add_src = esc;
		     siz = 2'b10;
		  end 
		  default: begin 
		     alu = ALU_EA;
		     siz_a_o = 2'b10;
		     add_a_o = op_i[5:0];
		     add_b_o = esc;
		     
		     src = dat_c_i;
		     add_src = esc;
		     add_dst = 6'b100111; 
		     siz = 2'b10;
		     
		  end 
		endcase 
	     end 
	     6'h2B: begin
		case (op_i[5:0])
		  6'h3C: begin 
		     
		     add_a_o = esc;
		     add_b_o = esc;
		     siz_a_o = 2'b00;
		     
		     alu = ALU_VECTOR;
		     src = 6'd4;
		     
		     add_dst = 6'h3C;
		     add_src = esc;
		     siz = 2'b10;

		  end 
		  default: begin 
		     alu = ALU_TAS;
		     siz_a_o = op_i[7:6];
		     add_a_o = esc;
		     add_b_o = op_i[5:0];
		     src = zero;
		     
		     add_src = esc;
		     add_dst = op_i[5:0];
		     siz = op_i[7:0];
		  end 
		endcase 
	     end 
	     6'h28,6'h29,6'h2A: begin 
		alu = ALU_TST;
		siz_a_o = op_i[7:6];
		add_a_o = esc;
		add_b_o = op_i[5:0];
		src = zero;
		
		add_src = esc;
		add_dst = op_i[5:0];
		siz = op_i[7:0];
		
	     end 
	     6'h39: begin
		case (op_i[5:3])
		  3'b000,3'b001: begin 
		     
		     add_a_o = esc;
		     add_b_o = esc;
		     siz_a_o = 2'b00;
		     
		     alu = ALU_VECTOR;
		     
		     src = {28'd2, op_i[3:0]};
		     add_dst = 6'h3C;
		     add_src = 6'h3C;
		     siz = 2'b10;

		  end 
		  3'b010: begin 
		     
		     
		     
		     alu = ALU_NOP;
		     
		     src = xxxx;
		     add_dst = 6'bxxxxxx;
		     add_src = 6'bxxxxxx;
		     siz = 2'bxx;
		     add_a_o = 6'bxxxxxx;
		     add_b_o = 6'bxxxxxx;
		     siz_a_o = 2'bxx;
		  end
		  3'b011: begin 
		     
		     
		     
		     alu = ALU_NOP;
		     
		     src = xxxx;
		     add_dst = 6'bxxxxxx;
		     add_src = 6'bxxxxxx;
		     siz = 2'bxx;
		     add_a_o = 6'bxxxxxx;
		     add_b_o = 6'bxxxxxx;
		     siz_a_o = 2'bxx;
		  end
		  
		  3'b100,3'b101: begin 
		     
		     
		     
		     alu = ALU_NOP;
		     
		     src = xxxx;
		     add_dst = 6'bxxxxxx;
		     add_src = 6'bxxxxxx;
		     siz = 2'bxx;
		     add_a_o = 6'bxxxxxx;
		     add_b_o = 6'bxxxxxx;
		     siz_a_o = 2'bxx;
		  end
		  
		  3'b110: begin
		     case (op_i[2:0])
		       3'h0: begin 
			  
			  add_a_o = esc;
			  add_b_o = esc;
			  siz_a_o = 2'b10;
			  
			  alu = ALU_MOV;
			  
			  src = reset;
			  add_dst = 6'h3C;
			  add_src = esc;
			  siz = 2'b10;
		       end 
		       3'h1: begin 
			  add_a_o = esc;
			  add_b_o = esc;
			  siz_a_o = 2'b11;
			  alu = ALU_NOP;
			  
			  src = zero;
			  add_dst = esc;
			  add_src = esc;
			  siz = 2'b11;
		       end 
		       3'h2: begin 
			  alu = ALU_STOP;
			  siz_a_o = 2'b10;
			  add_a_o = 6'h3C;
			  add_b_o = 6'h3D;
			  
			  src = dat_a_i;
			  siz = 2'b10;
			  add_src = 6'h3C;
			  add_dst = 6'h3C;
			  			  
		       end 
		       3'h3: begin 
			  add_a_o = 6'h1F;
			  add_b_o = esc;
			  siz_a_o = 2'b10;
			  
			  alu = ALU_MOV;
			  
			  src = {dat_a_i[31:1],1'b0};
			  add_dst = 6'h3C;
			  add_src = esc;
			  siz = 2'b10;
		       end 
		       3'h5: begin 
			  add_a_o = 6'h1F;
			  add_b_o = esc;
			  siz_a_o = 2'b10;
			  
			  alu = ALU_MOV;
			  
			  src = {dat_a_i[31:1],1'b0};
			  add_dst = 6'h3C;
			  add_src = esc;
			  siz = 2'b10;
		       end 
		       3'h6: begin 
			  add_a_o = esc;
			  add_b_o = esc;
			  siz_a_o = 2'b00;
			  
			  alu = ALU_VECTOR;
			  
			  src = 3'd7;
			  add_dst = 6'h3C;
			  add_src = esc;
			  siz = 2'b10;
			  
		       end 
		       3'h7: begin 
			  add_a_o = 6'h1F;
			  add_b_o = esc;
			  siz_a_o = 2'b10;
			  
			  alu = ALU_MOV;
			  
			  src = {dat_a_i[31:1],1'b0};
			  add_dst = 6'h3C;
			  add_src = esc;
			  siz = 2'b10;
		       end 
		       
		       default: begin
			  alu = ALU_NOP;
			  
			  src = xxxx;
			  add_dst = 6'bxxxxxx;
			  add_src = 6'bxxxxxx;
			  siz = 2'bxx;
			  add_a_o = 6'bxxxxxx;
			  add_b_o = 6'bxxxxxx;
			  siz_a_o = 2'bxx;
		       end
		       
		     endcase 
		  end 
		  
		  default: begin
		     alu = ALU_NOP;
		     
		     src = xxxx;
		     add_dst = 6'bxxxxxx;
		     add_src = 6'bxxxxxx;
		     siz = 2'bxx;
		     add_a_o = 6'bxxxxxx;
		     add_b_o = 6'bxxxxxx;
		     siz_a_o = 2'bxx;
		  end
		  
		endcase 
	     end 
	     6'h3A: begin 
		add_a_o = op_i[5:0];
		add_b_o = 6'h3D;
		siz_a_o = 2'b10;
		
		alu = ALU_MOV;
		
		src = {dat_a_i[31:1],1'b1};
		add_dst = 6'h3C;
		add_src = esc;
		siz = 2'b10;
		
	     end 
	     6'h3B: begin 
		add_b_o = 6'h3D;
		siz_a_o = 2'b10;
		add_a_o = op_i[5:0];
		src = {dat_a_i[31:1],1'b0};

		siz = 2'b10;
		alu = ALU_MOV;
		
		add_dst = 6'h3C;
		add_src = esc;
		
	     end 
	     6'h07,6'h0F: begin 
		alu = ALU_EA;
		siz_a_o = 2'b10;
		add_a_o = op_i[5:0];
		add_b_o = {2'd1,op_i[11:9]};
		
		src = dat_c_i;
		add_src = esc;
		add_dst = {2'd1, op_i[11:9]}; 
		siz = 2'b10;
	     end 
	     6'h06,6'h0E: begin 
		
		
		
		alu = ALU_NOP;
		
		src = xxxx;
		add_dst = 6'bxxxxxx;
		add_src = 6'bxxxxxx;
		siz = 2'bxx;
		add_a_o = 6'bxxxxxx;
		add_b_o = 6'bxxxxxx;
		siz_a_o = 2'bxx;
	     end
	     default: begin
		alu = ALU_NOP;
		
		src = xxxx;
		add_dst = 6'bxxxxxx;
		add_src = 6'bxxxxxx;
		siz = 2'bxx;
		add_a_o = 6'bxxxxxx;
		add_b_o = 6'bxxxxxx;
		siz_a_o = 2'bxx;
	     end
	   endcase 
	   
	end 

	

	4'h5: begin 
	   case (op_i[7:6])
	     2'b11: begin 
		case (op_i[5:3])
		  3'b001: begin 
		     
		     
		     
		     alu = ALU_NOP;
		     
		     src = xxxx;
		     add_dst = 6'bxxxxxx;
		     add_src = 6'bxxxxxx;
		     siz = 2'bxx;
		     add_a_o = 6'bxxxxxx;
		     add_b_o = 6'bxxxxxx;
		     siz_a_o = 2'bxx;
		  end
		  default: begin 
		     alu = ALU_SCC;
		     siz_a_o = 2'b00;
		     add_a_o = esc;
		     add_b_o = op_i[5:0];

		     add_src = {2'b11, op_i[11:8]};
		     add_dst = op_i[5:0];
		     
		     src = zero;
		     siz = 2'b00;
		     
		  end 
		endcase 
	     end 
	     default: begin
		case (op_i[8])
		  1'b0: begin 
		     alu = ALU_ADD;
		     siz_a_o = op_i[7:6];
		     add_a_o = esc;
		     add_b_o = op_i[5:0];
		     
		     if (op_i[11:9]== 3'b000)
		       src = 32'd8;
		     else
		       src = op_i[11:9];
		     
		     
		     add_src = 6'h3C;
		     add_dst = op_i[5:0];
		     siz = op_i[7:6];
		     
		  end 
		  1'b1: begin 
		     alu = ALU_SUB;
		     siz_a_o = op_i[7:6];
		     add_a_o = esc;
		     add_b_o = op_i[5:0];
		
		     if (op_i[11:9]== 3'b000) 
		       src = 32'd8;
		     else
		       src = op_i[11:9];
		  	  	     
		     
		     add_src = 6'h3C;
		     add_dst = op_i[5:0];
		     siz = op_i[7:6];
		  end 
		endcase 
	     end 
	   endcase 
	end 
	
	

	4'h6: begin 
	   case (op_i[11:8])
	     4'h0: begin 
		add_b_o = 6'h3D;

		if (op_i[7:0]== 8'd0) begin
		   siz_a_o = 2'b01;
		   add_a_o = 6'h3C;
		   src = {16'd0,dat_a_i[15:1],1'b0};
		   siz = 2'b01;
		end else begin
		   siz_a_o = 2'b11;
		   add_a_o = esc;
		   src = {24'd0,op_i[7:1],1'b0};
		   siz = 2'b00;
		end 
				
		alu = ALU_ADD;
		
		add_dst = 6'h3C;
		add_src = esc;
	     end 
	     4'h1: begin 
		add_b_o = 6'h3D;

		if (op_i[7:0]==8'd0) begin
		   siz_a_o = 2'b01;
		   add_a_o = 6'h3C;
		   src = {16'd0,dat_a_i[15:1],1'b1};
		   siz = 2'b01;
		end else begin
		   siz_a_o = 2'b11;
		   add_a_o = esc;
		   src = {24'd0,op_i[7:1],1'b1};
		   siz = 2'b00;
		end 
				
		alu = ALU_ADD;
		
		add_dst = 6'h3C;
		add_src = esc;
	     end 
	     default: begin 
		add_b_o = 6'h3D;
		
		if (op_i[7:0]==8'd0) begin
		   siz_a_o = 2'b01;
		   add_a_o = 6'h3C;
		   src = {16'd0,dat_a_i[15:1],1'b0};
		   siz = 2'b01;
		end else begin
		   siz_a_o = 2'b11;
		   add_a_o = esc;
		   src = {24'd0,op_i[7:1],1'b0};
		   siz = 2'b00;
		end 
			
		alu = ALU_BCC;
		
		add_dst = 6'h3C;
		add_src = {2'b11, op_i[11:8]};
   
	     end 
	   endcase 
	end 
			
	

	4'h7: begin 
	   add_b_o = {3'd0,op_i[11:9]};
	   add_a_o = esc;
	   siz_a_o = 2'b11;

	   alu = ALU_MOV;
	   src = op_i[7:0];
	   
	   add_dst = {3'd0, op_i[11:9]};
	   add_src = esc;
	   siz = 2'b00;
	   	   
	end 
		
	

	4'h8: begin 
	   case (op_i[8:6])
	     3'b011: begin 










 
		alu = ALU_NOP;
		
		src = xxxx;
		add_dst = 6'bxxxxxx;
		add_src = 6'bxxxxxx;
		siz = 2'bxx;
		add_a_o = 6'bxxxxxx;
		add_b_o = 6'bxxxxxx;
		siz_a_o = 2'bxx;
 
	     end 
	     3'b111: begin 










 
		alu = ALU_NOP;
		
		src = xxxx;
		add_dst = 6'bxxxxxx;
		add_src = 6'bxxxxxx;
		siz = 2'bxx;
		add_a_o = 6'bxxxxxx;
		add_b_o = 6'bxxxxxx;
		siz_a_o = 2'bxx;
 
	     end 
	     default: begin
		case (op_i[5:4])
		  2'b00: begin 
		     alu = ALU_SBCD;
		     siz_a_o = 2'b00;
		     
		     add_a_o = {op_i[3],2'b00,op_i[11:9]};
		     add_b_o = {op_i[3],2'b00,op_i[2:0]};
       
		     src = dat_a_i;
		     
		     add_src = {op_i[3],2'b00,op_i[11:9]};
		     add_dst = {op_i[3],2'b00,op_i[2:0]};
		     siz = 2'b00;
		     
		  end 
		  default: begin 
		     alu = ALU_OR;
		     siz_a_o = op_i[7:6];
		     if (op_i[8]) begin
			add_a_o = {3'd0, op_i[11:9]};
			add_b_o = op_i[5:0];
			add_src = {3'd0, op_i[11:9]};
			add_dst = op_i[5:0];
			
		     end else begin
			add_b_o = {3'd0, op_i[11:9]};
			add_a_o = op_i[5:0];
			add_dst = {3'd0, op_i[11:9]};
			add_src = op_i[5:0];
		     end 

		     siz = op_i[7:6];
		     src = dat_a_i;
		     
		     
		  end 
		endcase 
	     end 
	   endcase 
	end 
		
	

	4'h9: begin 
	   case (op_i[8])
	     1'b1: begin
		case (op_i[7:6])
		  2'b11: begin 
		     alu = ALU_SUB;
		     siz_a_o = op_i[8:7];
		     add_b_o = {3'd1, op_i[11:9]};
		     add_a_o = op_i[5:0];
		     add_dst = {3'd1, op_i[11:9]};
		     add_src = op_i[5:0];
		     siz = op_i[8:7];
		     src = dat_a_i;
		     
		     
		  end 
		  default: begin 
		     case (op_i[5:4])
		       2'b00: begin
			  alu = ALU_SUBX;
			  siz_a_o = op[7:6];
			  add_a_o = {op_i[3], 2'b00, op_i[11:9]};
			  add_b_o = {op_i[3], 2'b00, op_i[2:0]};
			  add_src = {op_i[3], 2'b00, op_i[11:9]};
			  add_dst = {op_i[3], 2'b00, op_i[2:0]};
			  src = dat_a_i;
			  
			  siz = op[7:6];
		       end 
		       default: begin
			  alu = ALU_SUB;
			  siz_a_o = op_i[7:6];
			  add_a_o = {3'd0, op_i[11:9]};
			  add_b_o = op_i[5:0];
			  add_src = {3'd0, op_i[11:9]};
			  add_dst = op_i[5:0];
			  
			  siz = op_i[7:6];
			  src = dat_a_i;
			  
			  
		       end 
		     endcase 
		  end 
		endcase 
	     end 
	     default: begin 
		alu = ALU_SUB;
		siz_a_o = op_i[7:6];
		add_b_o = {3'd0, op_i[11:9]};
		add_a_o = op_i[5:0];
		add_dst = {3'd0, op_i[11:9]};
		add_src = op_i[5:0];
		
		siz = op_i[7:6];
		src = dat_a_i;
		
	     end 
	   endcase 
	end 
		
	

	4'hB: begin 
	   case (op_i[8:6])
	     3'h0,3'h1,3'h2: begin 
		alu = ALU_SUB;
		siz_a_o = op_i[7:6];
		add_a_o = op_i[5:0];
		add_b_o = {3'd0, op_i[11:9]};
	       	src = dat_a_i;
		
		add_src = op_i[5:0];
		add_dst = 6'h3C;
		siz = op_i[7:6];

	     end 
	     3'h3,3'h7: begin 
		alu = ALU_SUB;
		siz_a_o = op_i[8:7];
		add_a_o = op_i[5:0];
		add_b_o = {3'd1, op_i[11:9]};
	       	src = dat_a_i;
		
		add_src = op_i[5:0];
		add_dst = 6'h3C;
		siz = op_i[8:7];
		
	     end 
	     3'h4,3'h5,3'h6: begin
		case (op_i[5:3])
		  3'h1: begin 
		     alu = ALU_SUB;
		     siz_a_o = op_i[7:6];
		     add_a_o = {3'b011,op_i[2:0]};
		     add_b_o = {3'b011,op_i[11:9]};
		     add_src = {3'b011,op_i[2:0]};
		     add_dst = 6'h3C;
		     src = dat_a_i;
		     
		  end
		  default: begin 
		     alu = ALU_EOR;
		     siz_a_o = op_i[7:6];
		     add_a_o = {3'd0, op_i[11:9]};
		     add_b_o = op_i[5:0];
		     add_src = {3'd0, op_i[11:9]};
		     add_dst = op_i[5:0];
		     siz = op_i[7:6];
		     src = dat_a_i;
		     
		     
		  end 
		endcase 
	     end 
	   endcase 
	end 
		
	

	4'hC: begin 
	   case (op_i[8:6])
	     3'b011: begin 










 
		alu = ALU_NOP;
		
		src = xxxx;
		add_dst = 6'bxxxxxx;
		add_src = 6'bxxxxxx;
		siz = 2'bxx;
		add_a_o = 6'bxxxxxx;
		add_b_o = 6'bxxxxxx;
		siz_a_o = 2'bxx;
 
	     end 
	     3'b111: begin 










 
		alu = ALU_NOP;
		
		src = xxxx;
		add_dst = 6'bxxxxxx;
		add_src = 6'bxxxxxx;
		siz = 2'bxx;
		add_a_o = 6'bxxxxxx;
		add_b_o = 6'bxxxxxx;
		siz_a_o = 2'bxx;
 
	     end 
	     default: begin
		case (op_i[5:4])
		  2'b00: begin 
		     alu = ALU_ABCD;
		     siz_a_o = 2'b00;
		     
		     add_a_o = {op_i[3],2'b00,op_i[11:9]};
		     add_b_o = {op_i[3],2'b00,op_i[2:0]};
       
		     src = dat_a_i;
		     
		     add_src = {op_i[3],2'b00,op_i[11:9]};
		     add_dst = {op_i[3],2'b00,op_i[2:0]};
		     siz = 2'b00;
		  end 
		  default: begin 
		     alu = ALU_AND;
		     siz_a_o = op_i[7:6];

		     if (op_i[8]) begin
			add_a_o = {3'd0, op_i[11:9]};
			add_b_o = op_i[5:0];
			add_src = {3'd0, op_i[11:9]};
			add_dst = op_i[5:0];
		     end else begin
			add_b_o = {3'd0, op_i[11:9]};
			add_a_o = op_i[5:0];
			add_dst = {3'd0, op_i[11:9]};
			add_src = op_i[5:0];
		     end 
		     
		     siz = op_i[7:6];
		     src = dat_a_i;
		     
		     
		  end 
		endcase 
	     end 
	   endcase 
	end 
		
	

	4'hD: begin 
	   case (op_i[8])
	     1'b1: begin
		case (op_i[7:6])
		  2'b11: begin 
		     alu = ALU_ADD;
		     siz_a_o = op_i[8:7];
		     add_b_o = {3'd1, op_i[11:9]};
		     add_a_o = op_i[5:0];
		     add_dst = {3'd1, op_i[11:9]};
		     add_src = op_i[5:0];
		     siz = op_i[8:7];
		     src = dat_a_i;
		     
		  end 
		  default: begin 
		     case (op_i[5:4])
		       2'b00: begin
			  alu = ALU_ADDX;
			  siz_a_o = op[7:6];
			  add_a_o = {op_i[3], 2'b00, op_i[11:9]};
			  add_b_o = {op_i[3], 2'b00, op_i[2:0]};
			  add_src = {op_i[3], 2'b00, op_i[11:9]};
			  add_dst = {op_i[3], 2'b00, op_i[2:0]};
			  src = dat_a_i;
			  
			  siz = op[7:6];
		       end 
		       default: begin
			  alu = ALU_ADD;
			  siz_a_o = op_i[7:6];
			  add_a_o = {3'd0, op_i[11:9]};
			  add_b_o = op_i[5:0];
			  add_src = {3'd0, op_i[11:9]};
			  add_dst = op_i[5:0];
			  
			  siz = op_i[7:6];
			  src = dat_a_i;
			  
		       end 
		     endcase 
		  end 
		endcase 
	     end 
	     default: begin 
		alu = ALU_ADD;
		siz_a_o = op_i[7:6];
		add_b_o = {3'd0, op_i[11:9]};
		add_a_o = op_i[5:0];
		add_dst = {3'd0, op_i[11:9]};
		add_src = op_i[5:0];
		
		siz = op_i[7:6];
		src = dat_a_i;
		
	     end 
	   endcase 
	end 
	
	
	
	4'hE: begin 
	   case (op_i[7:6])
	     2'b11: begin
		case (op_i[10:9])













 













 













 
		  default: begin 
		     alu = ALU_ROX;
		     siz_a_o = 2'b10;
		     add_b_o = op_i[5:0];
		     add_a_o = esc;
		     add_dst = op_i[5:0];
		     add_src = {op_i[8],4'd1};

		     siz = 2'b10;
		     src = zero;
		     
		  end 
		endcase 
	     end 
	     default: begin
		case (op_i[4:3])


















 


















 


















 
		  default: begin 
		     alu = ALU_ROX;
		     siz_a_o = op_i[7:6];
		     add_b_o = {3'd0,op_i[2:0]};
		     add_a_o = {3'd0,op_i[11:9]};

		     add_dst = {3'd0,op_i[2:0]};

		     if (op_i[5])
		       add_src = {op_i[8],dat_a_i[4:0]};
		     else
		       add_src = {op_i[8],~(op_i[11]|op_i[10]|op_i[9]),op_i[11:9]};
		     		     		     
		     siz = op_i[7:6];
		     
		     src = zero;
		  end 
		endcase 
	     end 
	   endcase 
	   
	end 
		
	

	default: begin 
	   alu = ALU_NOP;
	   
	   src = xxxx;
	   add_dst = 6'bxxxxxx;
	   add_src = 6'bxxxxxx;
	   siz = 2'bxx;
	   add_a_o = 6'bxxxxxx;
	   add_b_o = 6'bxxxxxx;
	   siz_a_o = 2'bxx;
	end
      endcase 
      end 
            
   end 

   
   
   
   
   

       
   
   
   
   
   
   always @(add_c_i or alu_i or alu_pc_i or brch or res_i
	    or rst_i or siz_i) begin
      if (rst_i) begin
	 
	 
	 add_c_o = 0;
	 brch_o = 0;
	 c_siz_o = 0;
	 dat_c_o = 0;
	 pc_o = 0;
	 
	 
      end else begin 
	 c_siz_o = siz_i;
	 
	 case (add_c_i)
	   6'h3c:
	    case (alu_i)
	      ALU_STOP: begin
		 brch_o = 1'b1;
		 pc_o = res_i;
		 add_c_o = esc;
		 dat_c_o = xxxx;
		 
	      end
	      
	      ALU_ADD,ALU_MOV,ALU_BCC,ALU_VECTOR: begin 
		 brch_o = 1'b1;
		 pc_o = {res_i[aw-1:1],1'b0};
		 case (res_i[0]) 
		   1'b1: begin
		      add_c_o = 6'h27;
		      dat_c_o = {alu_pc_i[aw-1:1],1'b0};
		   end
		   default: begin
		      add_c_o = esc;
		      dat_c_o = xxxx;
		   end
		 endcase 
	      end 
	      
	      default: begin
		 brch_o = 1'b0;
		 pc_o = xxxx;
		 add_c_o = esc;
		 dat_c_o = xxxx;
		 
	      end
	      
	    endcase 
	   
	   6'h3F: begin
	      add_c_o = esc;
	      dat_c_o = xxxx;
	      brch_o = 1'b0;
	      pc_o = xxxx;
	   end
	   
	   default: 
	     if (~brch) begin
		brch_o = 1'b0;
		pc_o = xxxx;
		
		case (alu_i)
		  ALU_NOP: begin
		     add_c_o = esc;
		     dat_c_o = xxxx;
		  end
		  default: begin
		     
		     add_c_o = add_c_i;
		     dat_c_o = res_i;
		  end
		endcase 
	     end else begin
		add_c_o = esc;
		dat_c_o = xxxx;
		brch_o = 1'b0;
		pc_o = zero;
	     end 
	   
	 endcase 
	 
      end 
      
   end 

   
   
   
      
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps
















































































































































































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_dpmem.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_dpmem.v"






module k68_dpmem(
   
   dat_r_o, 
   
   add_r_i, add_w_i, dat_w_i, clk_i, rst_i, we_i
   );
   parameter gw =  6'd4;
   parameter dw =  6'd32;

   input [gw-1:0] add_r_i, add_w_i;
   input [dw-1:0] dat_w_i;
   output [dw-1:0] dat_r_o;
   input 	   clk_i, rst_i, we_i;

   wire [7:0] 	   r_add,w_add;
   
   assign 	   r_add = 8'hFF & add_r_i;
   assign 	   w_add = 8'hFF & add_w_i;
   
   reg [dw-1:0]    mem [(1<<gw)-1:0];
      
   
   always @ (posedge clk_i)
     if (we_i) mem[add_w_i] <= dat_w_i;
   
   assign 	   dat_r_o = mem[add_r_i];

        
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_execute.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_execute.v"


module k68_execute (
   
   res_o, ccr_o, ssr_o, add_c_o, alu_o, siz_o, pc_o, 
   
   clk_i, rst_i, alu_i, src_i, dst_i, add_src_i, add_dst_i, siz_i, pc_i, int_i, skip_i
   ) ;

   parameter dw =  6'd32;
   parameter lw =  3'd6;
   parameter kw = 6;
   parameter sw =  6'd8;
   parameter zero =  32'd0;
   parameter xxxx =  32'bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
   parameter esc =  6'h3F;
   parameter aw =  6'd32;
   parameter ccr =  8'h00;
   parameter ssr =  8'h00;
   
   
   parameter ZF =  3'd2;
   parameter CF =  3'd0;
   parameter VF =  3'd1;
   parameter NF =  3'd3;
   parameter XF =  3'd4;
   
   
   parameter ALU_ABCD =  6'h0D;
   parameter ALU_SBCD =  6'h0A;
   parameter ALU_NBCD =  6'h11;
   parameter ALU_ADD =  6'h0B;
   parameter ALU_ADDX =  6'h0C;
   parameter ALU_SUB =  6'h08;
   parameter ALU_SUBX =  6'h09;
   parameter ALU_OR =  6'h04;
   parameter ALU_AND =  6'h05;
   parameter ALU_EOR =  6'h06;
   parameter ALU_BTST =  6'h18;
   parameter ALU_BCHG =  6'h19;
   parameter ALU_BCLR =  6'h1A;
   parameter ALU_BSET =  6'h1B;
   parameter ALU_MOV =  6'h3F;
   parameter ALU_DIV =  6'h0F;
   parameter ALU_MUL =  6'h0E;
   parameter ALU_ASX =  6'h1C;
   parameter ALU_LSX =  6'h1D;
   parameter ALU_ROX =  6'h1F;
   parameter ALU_ROXX =  6'h1E;
   parameter ALU_NOT =  6'h07;
   parameter ALU_NOP =  6'h00;
   parameter ALU_NEGX =  6'h12;
   parameter ALU_NEG =  6'h10;
    
   parameter ALU_ANDSR =  6'h02;
   parameter ALU_ORSR =  6'h01;
   parameter ALU_EORSR =  6'h03;
   parameter ALU_MOVSR =  6'h14;

   parameter ALU_BCC =  6'h15;
   parameter ALU_DBCC =  6'h16;
   parameter ALU_SCC =  6'h17;
   parameter ALU_SWAP =  6'h20;
   parameter ALU_STOP =  6'h21;

   parameter ALU_VECTOR =  6'h22;
   parameter ALU_TAS =  6'h23;
   parameter ALU_TST =  6'h24;
   parameter ALU_EA =  6'h25;
   parameter ALU_CMP =  6'h13;
      
   output [dw-1:0] res_o;
   output [7:0]    ccr_o, ssr_o;
   output [kw-1:0] add_c_o;
   output [lw-1:0] alu_o;
   output [1:0]    siz_o;
   reg [1:0] 	   siz_o;
      
   input 	   clk_i, rst_i;
   input [lw-1:0]  alu_i;
   input [dw-1:0]  src_i, dst_i;
   input [kw-1:0]  add_src_i, add_dst_i;
   input [1:0] 	   siz_i;
   input [aw-1:0]  pc_i;
   input [2:0] 	   int_i;
   output [aw-1:0] pc_o;
   input [1:0] 	   skip_i;
        
   reg [dw-1:0]    res_o;
   reg [sw-1:0]    ccr_o, ssr_o;
   reg [kw-1:0]    add_c_o, add_c;
   reg [lw-1:0]    alu_o, alu;
   reg [aw-1:0]    pc_o, pc;
   reg [dw-1:0]    src,dst;
   reg [dw-1:0]	   res;

   wire [7:0] 	   d2ba,d2bb,b2d;
   wire 	   flag;
   reg [7:0] 	   bcd;
   wire [dw-1:0]   res_rox,res_lsx,res_asx,res_roxx;
   wire 	   x;
   reg 		   c;
     
            
   
   
   
   
   always @ (posedge clk_i) begin
      if (rst_i) begin
	 
	 
	 add_c_o <= 0;
	 alu_o <= 0;
	 ccr_o <= 0;
	 pc_o <= 0;
	 res_o <= 0;
	 siz_o <= 0;
	 ssr_o <= 0;
	 
	 
	 ssr_o <= ssr;
	 ccr_o <= ccr;
	 
      end else begin

	 pc_o <= pc_i+{skip_i,1'b0};
	 alu_o <= alu;
	 add_c_o <= add_c;
	 siz_o <= siz_i;
	 
	 
	 
	 
	 case (alu_i)
	   ALU_ABCD, ALU_SBCD, ALU_NBCD: begin
	      ccr_o[XF] <= c;
	      ccr_o[NF] <= 1'bX;
	      ccr_o[ZF] <= (res[31:0] == zero) & ccr_o[ZF];
	      ccr_o[VF] <= 1'bx;
	      ccr_o[CF] <= c;
	   end
	   ALU_ADD: begin
	      ccr_o[XF] <= src[31] & dst[31] | ~res[31] & dst[31] | src[31] & ~res[31];
	      ccr_o[NF] <= res[31];
	      ccr_o[ZF] <= (res[31:0] == zero);
	      ccr_o[VF] <= src[31] & dst[31] & ~res[31] | ~src[31] & ~dst[31] & res[31];
	      ccr_o[CF] <= src[31] & dst[31] | ~res[31] & dst[31] | src[31] & ~res[31];
	   end
	   ALU_ADDX: begin
	      ccr_o[XF] <= src[31] & dst[31] | ~res[31] & dst[31] | src[31] & ~res[31];
	      ccr_o[NF] <= ccr_o[NF];
	      ccr_o[ZF] <= (res[31:0] == zero) & ccr_o[ZF];
	      ccr_o[VF] <= src[31] & dst[31] & ~res[31] | ~src[31] & ~dst[31] & res[31];
	      ccr_o[CF] <= src[31] & dst[31] | ~res[31] & dst[31] | src[31] & ~res[31];
	   end
	   ALU_MOV,ALU_AND,ALU_EOR,ALU_OR,ALU_NOT,ALU_TAS,ALU_TST: begin
	      ccr_o[XF] <= ccr_o[XF];
	      ccr_o[NF] <= res[31];
	      ccr_o[ZF] <= (res[31:0] == zero);
	      ccr_o[VF] <= 1'b0;
	      ccr_o[CF] <= 1'b0;
	   end
	   ALU_SUB: begin
	      ccr_o[XF] <= src[31] & ~dst[31] | res[31] & ~dst[31] | src[31] & res[31];
	      ccr_o[NF] <= res[31];
	      ccr_o[ZF] <= (res[31:0] == zero);
	      ccr_o[VF] <= ~src[31] & dst[31] & ~res[31] | src[31] & ~dst[31] & res[31];
	      ccr_o[CF] <= src[31] & ~dst[31] | res[31] & ~dst[31] | src[31] & res[31];
	   end
	   ALU_SUBX: begin
	      ccr_o[XF] <= src[31] & ~dst[31] | res[31] & ~dst[31] | src[31] & res[31];
	      ccr_o[NF] <= res[31];
	      ccr_o[ZF] <= (res[31:0] == zero) & ccr_o[ZF];
	      ccr_o[VF] <= ~src[31] & dst[31] & ~res[31] | src[31] & ~dst[31] & res[31];
	      ccr_o[CF] <= src[31] & ~dst[31] | res[31] & ~dst[31] | src[31] & res[31];
	   end
	   ALU_CMP: begin
	      ccr_o[XF] <= ccr_o[XF];
	      ccr_o[NF] <= res[31];
	      ccr_o[XF] <= (res[31:0] == zero);
	      ccr_o[VF] <= ~src[31] & dst[31] & ~res[31] | src[31] & ~dst[31] & res[31];
	      ccr_o[CF] <= src[31] & ~dst[31] | res[31] & ~dst[31] | src[31] & res[31];
	   end








	   	   









	   ALU_NEG: begin
	      ccr_o[XF] <= dst[31] | res[31];
	      ccr_o[NF] <= res[31];
	      ccr_o[ZF] <= (res[31:0] == zero);
	      ccr_o[VF] <= dst[31] & res[31];
	      ccr_o[CF] <= dst[31] | res[31];
	   end
	   ALU_NEGX: begin
	      ccr_o[XF] <= dst[31] | res[31];
	      ccr_o[NF] <= res[31];
	      ccr_o[ZF] <= (res[31:0] == zero) & ccr_o[ZF];
	      ccr_o[VF] <= dst[31] & res[31];
	      ccr_o[CF] <= dst[31] | res[31];
	   end
	   ALU_BSET,ALU_BTST,ALU_BCLR,ALU_BCHG: begin
	      ccr_o[XF] <= ccr_o[XF];
	      ccr_o[NF] <= ccr_o[NF];
	      ccr_o[VF] <= ccr_o[VF];
	      ccr_o[CF] <= ccr_o[CF];
	      ccr_o[ZF] <= ~dst[src[28:24]];
	   end
	   ALU_ROX: begin
	      ccr_o[XF] <= ccr_o[XF];
	      ccr_o[NF] <= res[31];
	      ccr_o[ZF] <= (res[31:0] == zero);
	      ccr_o[VF] <= 1'b0;
	      ccr_o[CF] <= x;
	   end



























	   ALU_MOVSR: {ssr_o, ccr_o} <= res[31:16];
	   ALU_STOP: {ssr_o,ccr_o} <= src[15:0];
	   default: begin
	      ccr_o <= ccr_o;
	      ssr_o <= {ssr_o[7:3],int_i};
	   end
	   
	 endcase 

	 
	 
	 
	 
	 
	 case (siz_i)
	   2'b00: res_o <= {dst_i[31:8],res[31:24]}; 
	   2'b01: res_o <= {dst_i[31:16],res[31:16]}; 
      	   default: res_o <= res[31:0]; 
	   
	 endcase 
      end
    
   end

   
   
   
   always @ (add_c_o or add_dst_i or add_src_i or alu_i or dst_i or res_o or rst_i
	     or siz_i or src_i) begin
      if (rst_i) begin
	 
	 
	 dst = 0;
	 src = 0;
	 
      end else begin
	 	 	 
	 
	 
	 
	 case(alu_i)
	   ALU_ROX:
	     case (siz_i)
	       2'b00: begin 
		  src = {src_i[7:0],src_i[7:0],src_i[7:0],src_i[7:0]};
		  if ((add_dst_i == add_c_o) && ~(add_c_o == 6'b111100) && ~(add_c_o == esc))
		    dst = {res_o[7:0],res_o[7:0],res_o[7:0],res_o[7:0]};
		  else
		    dst = {dst_i[7:0],dst_i[7:0],dst_i[7:0],dst_i[7:0]};
	       end
	       2'b01: begin 
		  src = {src_i[15:0],src_i[15:0]};
		  if ((add_dst_i == add_c_o) && ~(add_c_o == 6'b111100) && ~(add_c_o == esc))
		    dst = {res_o[15:0],res_o[15:0]};
		  else
		    dst = {dst_i[15:0],dst_i[15:0]};
	       end
	       default: begin 
		  src = src_i;
		  if ((add_dst_i == add_c_o) && ~(add_c_o == 6'b111100) && ~(add_c_o == esc))
		    dst = res_o;
		  else
		    dst = dst_i;
	       end
	     endcase 
	   
	   default:
	     case (siz_i)
	       2'b00: begin 
		  if ((add_src_i == add_c_o) && ~(add_c_o == 6'b111100) && ~(add_c_o == esc))
		    src = {res_o[7:0],24'd0};
		  else
		    src = {src_i[7:0],24'd0};
		  if ((add_dst_i == add_c_o) && ~(add_c_o == 6'b111100) && ~(add_c_o == esc))
		    dst = {res_o[7:0],24'd0};
		  else
		    dst = {dst_i[7:0],24'd0};
	       end
	       2'b01: begin 
		  if ((add_src_i == add_c_o) && ~(add_c_o == 6'b111100) && ~(add_c_o == esc))
		    src = {res_o[15:0],16'd0};
		  else
		    src = {src_i[15:0],16'd0};
		  if ((add_dst_i == add_c_o) && ~(add_c_o == 6'b111100) && ~(add_c_o == esc))
		    dst = {res_o[15:0],16'd0};
		  else
		    dst = {dst_i[15:0],16'd0};
	       end
	       default: begin 
		  if ((add_src_i == add_c_o) && ~(add_c_o == 6'b111100) && ~(add_c_o == esc))
		    src = res_o;
		  else
		    src = src_i;
		  if ((add_dst_i == add_c_o) && ~(add_c_o == 6'b111100) && ~(add_c_o == esc))
		    dst = res_o;
		  else
		    dst = dst_i;
	       end
	     endcase 
	 endcase 

      end 
   end 

   
   always @(add_dst_i or add_src_i or alu_i or ccr_o or d2ba or d2bb or flag or pc_i
	    or rst_i) begin
      if (rst_i) begin
	 
	 
	 add_c = 0;
	 alu = 0;
	 bcd = 0;
	 c = 0;
	 pc = 0;
	 
      end else begin
	 
	 alu = alu_i;
	 pc = pc_i;
	 
	 
	 
	 
	 case (alu_i)
	   
	   ALU_ADD: begin
	      add_c = add_dst_i;
	   end
	   ALU_SUB: begin
	      add_c = add_dst_i;
	   end










	   ALU_NEG: begin
	      add_c = add_dst_i;
	   end
	   ALU_ADDX: begin
	      add_c = add_dst_i;
	   end
	   ALU_SUBX: begin
	      add_c = add_dst_i;
	   end
	   ALU_NEGX: begin
	      add_c = add_dst_i;
	   end
	   
	   ALU_CMP: begin
	      add_c = esc;
	   end
	   
	   ALU_ABCD: begin
	      {c,bcd} = d2ba + d2bb + ccr_o[XF];
	      add_c = add_dst_i;
	   end
 	   ALU_SBCD: begin
	      {c,bcd} = d2bb - d2ba - ccr_o[XF];
	      add_c = add_dst_i;
	   end
	   ALU_NBCD: begin
	      {c,bcd} = 8'd0 - d2bb - ccr_o[XF];
	      add_c = add_dst_i;
	   end
	   















	   ALU_ROX: begin
	      add_c = add_dst_i;
	   end
	   
	   ALU_AND: begin
	      add_c = add_dst_i;
	   end
	   ALU_OR: begin
	      add_c = add_dst_i;
	   end
	   ALU_EOR: begin
	      add_c = add_dst_i;
	   end
	   ALU_NOT: begin
	      add_c = add_dst_i;
	   end
	   
	   ALU_ANDSR: begin
	      add_c = add_dst_i;
	   end
	   ALU_ORSR: begin
	      add_c = add_dst_i;
	   end
	   ALU_EORSR: begin
	      add_c = add_dst_i;
	   end
	   ALU_MOVSR: begin
	      add_c = add_dst_i;
	   end
	   
	   ALU_MOV: begin
	      add_c = add_dst_i;
	   end
	   
	   ALU_BCHG: begin
	      add_c = add_dst_i;
	   end
	   ALU_BCLR: begin
	      add_c = add_dst_i;
	      
	   end
	   ALU_BSET: begin
	      add_c = add_dst_i;
	   end
	   ALU_BTST: begin
	      add_c = 6'h3C;
	   end
	   
	   ALU_BCC:
	      case(flag)
		1'b1: begin
		   add_c = add_dst_i;
		end 
		default: begin
		   add_c = esc;
		end
	      endcase 

	   ALU_SCC:
	     case (flag)
	       1'b1: begin
		  add_c = add_dst_i;
	       end
	       default: begin
		  add_c = add_dst_i;
	       end
	     endcase 
	   
	   ALU_SWAP: begin
	      add_c = add_dst_i;
	   end

	   ALU_STOP: begin
	      add_c = 6'h3C;
	   end

	   ALU_VECTOR: begin
	      case (add_src_i)
		6'h3C: begin
		   add_c = 6'h3C;
		end
		default: 
		  if (ccr_o[VF])  begin
		       add_c = 6'h3C;
		    end else begin
		       add_c = ALU_NOP;
		    end
	      endcase 
	   end
	   ALU_TAS: begin
	      add_c = add_dst_i;
	   end
	   ALU_TST: begin
	      add_c = add_dst_i;
	   end
	   ALU_EA: begin
	      add_c = add_dst_i;
	   end
	   default: begin
	      add_c = add_c;
	   end
	 endcase 
      end
   end

   always @(add_dst_i or add_src_i or alu_i or b2d or ccr_o or dst or flag or res_asx
	    or res_lsx or res_rox or res_roxx or rst_i or src or ssr_o) begin
      if (rst_i) begin
	 
	 
	 res = 0;
	 
      end else begin
	 
	 
	 
	 
	 
	 case (alu_i)
	   
	   ALU_ADD: begin
	      res = src + dst;
	   end
	   ALU_SUB: begin
	      res = dst - src;
	   end










	   ALU_NEG: begin
	      res = zero - dst;
	   end
	   ALU_ADDX: begin
	      res = src + dst + ccr_o[XF];
	   end
	   ALU_SUBX: begin
	      res = dst - src - ccr_o[XF];
	   end
	   ALU_NEGX: begin
	      res = zero - dst - ccr_o[XF];
	   end
	   
	   ALU_CMP: begin
	      res = dst - src;
	   end
	   
	   ALU_ABCD: begin
	      {res[31:0]} = {b2d, 24'd0};
	   end
 	   ALU_SBCD: begin
	      {res[31:0]} = {b2d, 24'd0};
	   end
	   ALU_NBCD: begin
	      {res[31:0]} = {b2d, 24'd0};
	   end
	   















	   ALU_ROX: begin
	      res = res_rox;
	   end
	   
	   ALU_AND: begin
	      res = dst & src;
	   end
	   ALU_OR: begin
	      res = dst | src;
	   end
	   ALU_EOR: begin
	      res = dst ^ src;
	   end
	   ALU_NOT: begin
	      res = ~dst;
	   end
	   
	   ALU_ANDSR: begin
	      res = {ssr_o,ccr_o,16'd0} & src;
	   end
	   ALU_ORSR: begin
	      res = {ssr_o,ccr_o,16'd0} | src;
	   end
	   ALU_EORSR: begin
	      res = {ssr_o,ccr_o,16'd0} ^ src;
	   end
	   ALU_MOVSR: begin
	      if(add_dst_i==6'h3C)
		res = { (ssr_o & dst[31:24]) | src[31:24] , src[23:16], 16'd0};
	      else
		res = {ssr_o, ccr_o, 16'd0};
	   end
	   
	   ALU_MOV: begin
	      res = src;
	   end
	   
	   ALU_BCHG: begin
	      res = dst;
	      res[src[28:24]] = ~dst[src[28:24]];
	   end
	   ALU_BCLR: begin
	      res = dst;
	      res[src[28:24]] = 1'b0;
	   end
	   ALU_BSET: begin
	      res = dst;
	      res[src[28:24]] = 1'b1;
	   end
	   ALU_BTST: begin
	      res = dst;
	   end
	   
	   ALU_BCC:
	      case(flag)
		1'b1: begin
		   res = src + dst;
		end 
		default: begin
		   res = zero;
		end
	      endcase 
	   ALU_SCC:
	     case (flag)
	       1'b1: begin
		  res = 32'hFFFFFFFF;
	       end
	       default: begin
		  res = zero;
	       end
	     endcase 
	   
	   ALU_SWAP: begin
	      res = {dst[15:0],dst[31:16]};
	   end
	   ALU_STOP: begin
	      res = dst - 2'b10;
	   end
	   ALU_VECTOR: begin
	      case (add_src_i)
		6'h3C: begin
		   res = ((src[5:0] + dst[5:0]) << 2) | 1'b1;
		end
		default: 
		  if (ccr_o[VF])  begin
		       res = ((src[5:0] + dst[5:0]) << 2) | 1'b1;
		    end else begin
		       res = zero;
		    end
	      endcase 
	   end
	   ALU_TAS: begin
	      res = {1'b1, dst[30:0]};
	   end
	   ALU_TST: begin
	      res = dst;
	   end
	   ALU_EA: begin
	      res = dst;
	   end
	   default: begin
	      res = zero;
	   end
	 endcase 
      end
   end

   
   
   
   

   




   
   
   
   k68_rox rox0(
		.step(src[5:0]),
		.in(dst),
		.res(res_rox)
		);
























   
   
   
   



   
   
   
   


         
   
   
   
   k68_d2b d2b0(
		.d(src[31:24]),
		.b(d2ba)
		);
   
   k68_d2b d2b1(
		.d(dst[31:24]),
		.b(d2bb)
		);
   
   k68_b2d b2d0(
		.b(bcd),
		.d(b2d)
		);
   

   
   
   
   k68_ccc ccc0(
		.cc(ccr_o),
		.code(add_src_i[3:0]),
		.flag(flag)
		);
   
   
endmodule 



`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_fetch.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_fetch.v"

  
module k68_fetch (
   
   p_cs_o, p_add_o, pc_o, op_o, imm_o, 
   
   p_dat_i, cpu_clk_i, mem_clk_i, rst_i, brch_i, pc_i
   ) ;
   parameter dw =  6'd32;
   parameter aw =  6'd32;
   parameter nop =  16'b0100111001110001;
   parameter ow =  6'd16;
   parameter zero =  32'd0;
   parameter reset =  32'h00000000;
               
   input [ow-1:0] p_dat_i;
   input 	    cpu_clk_i,mem_clk_i,rst_i, brch_i;
   output 	    p_cs_o;
   output [aw-1:0]  p_add_o, pc_o;
   input [aw-1:0]   pc_i;
   output [ow-1:0] op_o;
   output [dw-1:0]   imm_o;

   reg 		     rdy;
   reg [ow-1:0]      op_o,immh_o,imml_o, tmpa,tmpb,tmpc,tmpd;

   
   reg [1:0] 	     mem_cnt, cpu_cnt;
    
   reg [aw-1:0]      p_add_o,pc;

   assign 	     pc_o = pc;
   
   assign 	     imm_o = {immh_o, imml_o};
   assign 	     p_cs_o = 1'b1;
       
   
   
   
      
   always @ (posedge cpu_clk_i) begin
      if (rst_i) begin
	 
	 
	 cpu_cnt <= 0;
	 immh_o <= 0;
	 imml_o <= 0;
	 op_o <= 0;
	 p_add_o <= 0;
	 pc <= 0;
	 
	 p_add_o <= reset;
	 pc <= reset;
	 op_o <= nop;
	 	 
      end else begin
	 if (rdy) begin
	    case (cpu_cnt)
	   
	      2'b00: begin
		 op_o <= tmpa;
		 immh_o <= tmpb;
		 imml_o <= tmpc;
		 
	      end
	      
	      2'b01: begin
		 op_o <= tmpb;
		 immh_o <= tmpc;
		 imml_o <= tmpd;
		 
	      end
	      
	      2'b10: begin
		 op_o <= tmpc;
		 immh_o <= tmpd;
		 imml_o <= tmpa;
		 
	      end
	      
	      2'b11: begin
		 op_o <= tmpd;
		 immh_o <= tmpa;
		 imml_o <= tmpb;
		 
	      end
	   
	    endcase 
	 end else begin 
	    op_o <= nop;
	    {immh_o, imml_o} <= zero;
	    
	 end 
	 
	 	 
	 if (brch_i) begin
	    pc <= pc_i;
	    cpu_cnt <= 2'd0;
	    p_add_o <= pc_i;
	    
	 end else begin
	    
	    if (rdy) begin
	       pc <= pc + 2'd2;
	    end
   	    
	    p_add_o <= p_add_o + 2'd2;
	    cpu_cnt <= cpu_cnt + 1'd1;
	    
	 end 

      end
      
   end

   
   
   
   
   always @ (brch_i or p_add_o or pc or rst_i) begin
      if (rst_i || brch_i) begin
	 
	 
	 rdy = 0;
	 
      end else if (p_add_o[3:1] - pc[3:1] == 3'd3) begin
	 rdy = 1'b1;
      end else begin
	 rdy = 1'b0;
	 	 
      end
    
   end 


   wire [ow-1:0]     s_dat_i;
     

   assign 	     s_dat_i = {p_dat_i[7:0],p_dat_i[15:8]};



      
   
   
   
   always @(posedge mem_clk_i) begin
      if (rst_i) begin
	 
	 
	 mem_cnt <= 0;
	 tmpa <= 0;
	 tmpb <= 0;
	 tmpc <= 0;
	 tmpd <= 0;
	 

	 tmpa <= nop;
	 tmpb <= nop;
	 tmpc <= nop;
	 tmpd <= nop;
	 	 
      end else begin
	  	 
	 if (mem_cnt == 2'b00) begin
	    case (cpu_cnt)
	      2'b00: tmpd <= s_dat_i;
	      2'b01: tmpa <= s_dat_i;
	      2'b10: tmpb <= s_dat_i;
	      2'b11: tmpc <= s_dat_i;
	      
	    endcase 
	    
	 end
	 
	 if (brch_i) begin
	    tmpd <= nop;
	    tmpa <= nop;
	    tmpc <= nop;
	    tmpb <= nop;
	    
	 end
	 
	 mem_cnt <= mem_cnt + 1'd1;
	 
      end
      
      
   end
     
   
endmodule 



`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_load.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_load.v"


module k68_load (
   
   dat_a_o, dat_b_o, dat_c_o, skip_o, m_add_o, m_dat_o, m_cs_o, 
   m_we_o, rs_add_o, rt_add_o, rd_add_o, rd_dat_o, r_we_o, 
   
   rst_i, m_clk_i, dat_c_i, add_a_i, add_b_i, add_c_i, imm_i, siz_i, 
   clk_i, pc_i, c_siz_i, m_dat_i, rs_dat_i, rt_dat_i
   ) ;
   parameter dw =  6'd32;
   parameter aw =  6'd32;
   parameter gw =  6'd4;
   parameter kw = 6;
   parameter zero=  32'd0;
   parameter xxxx=  32'bxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx;
   parameter esc =  6'h3F;
      
   
   input     rst_i, m_clk_i;
      
   
   output [dw-1:0] dat_a_o, dat_b_o, dat_c_o;
   input [dw-1:0]  dat_c_i;
   output [1:0]    skip_o;
   input [kw-1:0]  add_a_i, add_b_i, add_c_i;
   input [dw-1:0]  imm_i;
   input [1:0] 	   siz_i;
   input 	   clk_i;
   input [aw-1:0]  pc_i;
   reg [dw-1:0]    dat_a_o, dat_b_o, dat_c_o;
   reg [1:0]	   skip_o;
   input [1:0] 	   c_siz_i;
   
   
   output [aw-1:0] m_add_o;
   output [dw-1:0] m_dat_o;
   input [dw-1:0]  m_dat_i;
   output 	   m_cs_o;
   output 	   m_we_o;

   reg [aw-1:0]    m_add_o;
   reg [dw-1:0]    m_dat_o;
   reg [1:0] 	   m_cnt;
   reg 		   m_we, m_cs_o, m_we_o;

   
   output [gw-1:0] rs_add_o, rt_add_o, rd_add_o;
   output [dw-1:0] rd_dat_o;
   input [dw-1:0]  rs_dat_i, rt_dat_i;
   output 	   r_we_o;
   
   wire [aw-1:0]    ea;
   wire [dw-1:0]    dat;
   wire [1:0] 	    skip;
   reg 		    we;
   reg [kw-1:0]     add;
   reg [1:0] 	    skipa, skipb;
   reg [1:0] 	    siz;

     
   
   
   
   
   always @(add_a_i or add_b_i or add_c_i or c_siz_i
	    or m_cnt or rst_i or siz_i) begin
      if (rst_i) begin
	 
	 
	 add = 0;
	 siz = 0;
	 we = 0;
	 
	 
      end else begin
	 case (m_cnt)
	   2'b01: begin
	      add = add_a_i;
	      we = 1'b0;
	      siz = siz_i;
	   end
	   2'b10: begin
	      add = add_b_i;
	      we = 1'b0;
	      siz = siz_i;
	   end
	   2'b00: begin
	      add = add_c_i;
	      we = 1'b1;
	      siz = c_siz_i;
	   end
	   2'b11: begin
	      add = esc;
	      we = 1'b0;
	      siz = 2'b00;
	   end
   	   
	 endcase 
	 
      end 
     
   end 
   
   
   
   
   always @(posedge m_clk_i) begin
      if (rst_i) begin
	 
	 
	 dat_a_o <= 0;
	 dat_b_o <= 0;
	 dat_c_o <= 0;
	 m_add_o <= 0;
	 m_cnt <= 0;
	 m_cs_o <= 0;
	 m_dat_o <= 0;
	 m_we_o <= 0;
	 skip_o <= 0;
	 skipa <= 0;
	 skipb <= 0;
	 
	 
      end else begin 

	 
	 
	 dat_a_o <= dat_a_o;
	 dat_b_o <= dat_b_o;
	 m_add_o <= m_add_o;
	 m_cs_o <= m_cs_o;
	 m_we_o <= m_we_o;
	 dat_c_o <= dat_c_o;
	 
	     
	 case(m_cnt)
	   2'b01: begin
	      skipa <= skip;
	      
	      case (add_a_i[5:3])
		3'h0,3'h1: dat_a_o <= dat;
	      	3'h7:
		  case (add_a_i[2:0])
		    3'h4,3'h5: dat_a_o <= dat;
		    default: begin
		       dat_a_o <= dat_a_o;
		       m_add_o <= ea;
		       m_we_o <= 1'b0;
		       m_cs_o <= 1'b1;
		       dat_c_o <= ea;
		    end
		    
		  endcase 
		default: begin
		   dat_c_o <= ea;
		   dat_a_o <= dat_a_o;
		   m_add_o <= ea;
		   m_we_o <= 1'b0;
		   m_cs_o <= 1'b1;
		end
		
	      endcase 
	   end 

	   2'b10: begin
	      skipb <= skip;
	      
	      case (add_b_i[5:3])
		3'h0,3'h1: dat_b_o <= dat;
	      	3'h7:
		  case (add_b_i[2:0])
		    3'h4,3'h5: dat_b_o <= dat;
		    default: begin
		       dat_b_o <= dat_b_o;
		       m_add_o <= ea;
		       m_we_o <= 1'b0;
		       m_cs_o <= 1'b1;
		    end
		  endcase 
		default: begin
		   dat_b_o <= dat_b_o;
		   m_add_o <= ea;
		   m_we_o <= 1'b0;
		   m_cs_o <= 1'b1;
		end
	      endcase 

	      case (add_a_i[5:3])
		3'h0,3'h1: dat_a_o <= dat_a_o;
	      	3'h7:
		  case (add_a_i[2:0])
		    3'h4,3'h5: dat_a_o <= dat_a_o;
		    default: begin
		       dat_a_o <= m_dat_i;
		    end
		    
		  endcase 
		default: begin
		   dat_a_o <= m_dat_i;
		end
		
	      endcase 
	   end 

	   2'b11: begin
	      if (skip_o == 2'b00)
		skip_o <= skipa + skipb;
	      else
		skip_o <= skip_o - 1;
	      	      
	      case (add_b_i[5:3])
		3'h0,3'h1: dat_b_o <= dat_b_o;
	      	3'h7:
		  case (add_b_i[2:0])
		    3'h4,3'h5: dat_b_o <= dat_b_o;
		    default: begin
		       dat_b_o <= m_dat_i;
		    end
		  endcase 
		default: begin
		   dat_b_o <= m_dat_i;
		end
	      endcase 
      
	   end 

	   2'b00: begin
	      m_add_o <= ea;
	      m_dat_o <= dat_c_i;
	      m_cs_o <= 1'b1;
	      	      
	      case (add_c_i[5:3])
		3'h0,3'h1:begin
		   m_we_o <= 1'b0;
		end
		3'h7: begin
		   case (add_c_i[2:0])
		     3'h4,3'h7,3'h5: begin
			m_we_o <= 1'b0;
		     end
		     default: m_we_o <= 1'b1;
		   endcase 
		end
		default: m_we_o <= 1'b1;
				
	      endcase 
   
	      
	   end
	   
	     
	 endcase 
	 
	 
	 m_cnt <= m_cnt + 1'b1;

      end 
   end 
       
	 
   
   k68_calc calc0(
		  .rs_add_o(rs_add_o), .rt_add_o(rt_add_o), .rd_add_o(rd_add_o),
		  .rd_dat_o(rd_dat_o), .r_we_o(r_we_o),

		  .ea_o(ea),
		  .dat_o(dat),
		  .skip_o(skip),

		  .we_i(we),
		  .add_i(add),
		  .dst_i(add_c_i),
		  
		  .imm_i(imm_i),
		  .dat_i(dat_c_i),
		  .pc_i(pc_i),
		  
		  .rs_dat_i(rs_dat_i), .rt_dat_i(rt_dat_i), .siz_i(siz),
		  .rst_i(rst_i)
		  );
     
  
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_lsx.v"




































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 37 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_lsx.v"





module k68_lsx (
   
   res, 
   
   in, step
   ) ;
   parameter dw =  6'd32;
   
   output [dw-1:0] res;
   input [dw-1:0] in;
   input [5:0] 	  step;
   reg [dw-1:0] 	  res;
  
   always @ ( in or step) begin
      if (step[5])
	res <= in >> step[4:0];
      else
	res <= in << step[4:0];
   end
   

endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_par_mul.v"




































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 37 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_par_mul.v"





module k68_par_mul (
   
   res, 
   
   src, dst
   ) ;
   parameter dw =  6'd32;

   output [dw:0] res;
   input [dw/2-1:0] src,dst;

         
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_prims.v"




































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 37 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_prims.v"

  



module k68_rox (
   
   res, 
   
   in, step
   ) ;
   parameter dw =  6'd32;
   
   output [dw-1:0] res;
   input [dw-1:0] in;
   input [5:0] 	  step;
   reg [dw-1:0] 	  res;
   reg [4:0] 		  move;
   
   always @ ( step) begin
      if (step[5]) 
	move <= 6'd32 - step[4:0];
      else
	move <= step[4:0];
   end
   	     
   always @ ( in or move) begin
      
      
      
      case (move)
	5'd01: res <= {in[30:0],in[31]};
	5'd02: res <= {in[29:0],in[31:30]};
	5'd03: res <= {in[28:0],in[31:29]};
	5'd04: res <= {in[27:0],in[31:28]};
	5'd05: res <= {in[26:0],in[31:27]};
	5'd06: res <= {in[25:0],in[31:26]};
	5'd07: res <= {in[24:0],in[31:25]};
	5'd08: res <= {in[23:0],in[31:24]};
	5'd09: res <= {in[22:0],in[31:23]};
	5'd10: res <= {in[21:0],in[31:22]};
	5'd11: res <= {in[20:0],in[31:21]};
	5'd12: res <= {in[19:0],in[31:20]};
	5'd13: res <= {in[18:0],in[31:19]};
	5'd14: res <= {in[17:0],in[31:18]};
	5'd15: res <= {in[16:0],in[31:17]};
	5'd16: res <= {in[15:0],in[31:16]};
	5'd17: res <= {in[14:0],in[31:15]};
	5'd18: res <= {in[13:0],in[31:14]};
	5'd19: res <= {in[12:0],in[31:13]};
	5'd20: res <= {in[11:0],in[31:12]};
	5'd21: res <= {in[10:0],in[31:11]};
	5'd22: res <= {in[9:0],in[31:10]};
	5'd23: res <= {in[8:0],in[31:9]};
	5'd24: res <= {in[7:0],in[31:8]};
	5'd25: res <= {in[6:0],in[31:7]};
	5'd26: res <= {in[5:0],in[31:6]};
	5'd27: res <= {in[4:0],in[31:5]};
	5'd28: res <= {in[3:0],in[31:4]};
	5'd29: res <= {in[2:0],in[31:3]};
	5'd30: res <= {in[1:0],in[31:2]};
	5'd31: res <= {in[0],in[31:1]};
	default: res <= {in[31:0]};
	
      endcase 
   end

endmodule 
  



module k68_roxx (
   
   res, 
   
   in, xin, step
   ) ;
   parameter dw =  6'd32;
   
   output [dw:0] res;
   input [dw-1:0] in;
   input 	xin;
   input [6:0] 	step;
   reg [dw:0] res;
   reg [5:0] 	move;
   
   always @ ( step) begin
      if (step[6]) 
	move <= 6'd33 - step[5:0];
      else
	move <= step[5:0];
   end
   	     
   always @ ( in or move or xin) begin
      
      
      
      case (move)
	6'd01: res <= {in[30:0],xin,in[31]};
	6'd02: res <= {in[29:0],xin,in[31:30]};
	6'd03: res <= {in[28:0],xin,in[31:29]};
	6'd04: res <= {in[27:0],xin,in[31:28]};
	6'd05: res <= {in[26:0],xin,in[31:27]};
	6'd06: res <= {in[25:0],xin,in[31:26]};
	6'd07: res <= {in[24:0],xin,in[31:25]};
	6'd08: res <= {in[23:0],xin,in[31:24]};
	6'd09: res <= {in[22:0],xin,in[31:23]};
	6'd10: res <= {in[21:0],xin,in[31:22]};
	6'd11: res <= {in[20:0],xin,in[31:21]};
	6'd12: res <= {in[19:0],xin,in[31:20]};
	6'd13: res <= {in[18:0],xin,in[31:19]};
	6'd14: res <= {in[17:0],xin,in[31:18]};
	6'd15: res <= {in[16:0],xin,in[31:17]};
	6'd16: res <= {in[15:0],xin,in[31:16]};
	6'd17: res <= {in[14:0],xin,in[31:15]};
	6'd18: res <= {in[13:0],xin,in[31:14]};
	6'd19: res <= {in[12:0],xin,in[31:13]};
	6'd20: res <= {in[11:0],xin,in[31:12]};
	6'd21: res <= {in[10:0],xin,in[31:11]};
	6'd22: res <= {in[9:0],xin,in[31:10]};
	6'd23: res <= {in[8:0],xin,in[31:9]};
	6'd24: res <= {in[7:0],xin,in[31:8]};
	6'd25: res <= {in[6:0],xin,in[31:7]};
	6'd26: res <= {in[5:0],xin,in[31:6]};
	6'd27: res <= {in[4:0],xin,in[31:5]};
	6'd28: res <= {in[3:0],xin,in[31:4]};
	6'd29: res <= {in[2:0],xin,in[31:3]};
	6'd30: res <= {in[1:0],xin,in[31:2]};
	6'd31: res <= {in[0],xin,in[31:1]};
	6'd32: res <= {xin,in[31:0]};
	default: res <= {in[31:0],xin};
	
      endcase 
   end

endmodule 




module k68_lsx (
   
   res, 
   
   in, step
   ) ;
   parameter dw =  6'd32;
   
   output [dw-1:0] res;
   input [dw-1:0] in;
   input [5:0] 	  step;
   reg [dw-1:0] 	  res;
  
   always @ ( in or step) begin
      if (step[5])
	res <= in >> step[4:0];
      else
	res <= in << step[4:0];
   end
   

endmodule 




module k68_asx (
   
   res, 
   
   in, step
   ) ;
   parameter dw =  6'd32;
   
   output [dw-1:0] res;
   input [dw-1:0] in;
   input [5:0] 	  step;
   reg [dw-1:0] 	  res;
  
   always @ ( in or step) begin
      if (step[5])
	if (in[31])
	  case (step[4:0])
	    5'd01: res <= {1'b1,in[31:1]};
	    5'd02: res <= {2'b11,in[31:2]};
	    5'd03: res <= {3'b111,in[31:3]};
	    5'd04: res <= {4'b1111,in[31:4]};
	    5'd05: res <= {5'b11111,in[31:5]};
	    5'd06: res <= {6'b111111,in[31:6]};
	    5'd07: res <= {7'b1111111,in[31:7]};
	    5'd08: res <= {8'b11111111,in[31:8]};
	    5'd09: res <= {9'b111111111,in[31:9]};
	    5'd10: res <= {10'b1111111111,in[31:10]};
	    5'd11: res <= {11'b11111111111,in[31:11]};
	    5'd12: res <= {12'b111111111111,in[31:12]};
	    5'd13: res <= {13'b1111111111111,in[31:13]};
	    5'd14: res <= {14'b11111111111111,in[31:14]};
	    5'd15: res <= {15'b111111111111111,in[31:15]};
	    5'd16: res <= {16'b1111111111111111,in[31:16]};
	    5'd17: res <= {17'b11111111111111111,in[31:17]};
	    5'd18: res <= {18'b111111111111111111,in[31:18]};
	    5'd19: res <= {19'b1111111111111111111,in[31:19]};
	    5'd20: res <= {20'b11111111111111111111,in[31:20]};
	    5'd21: res <= {21'b111111111111111111111,in[31:21]};
	    5'd22: res <= {22'b1111111111111111111111,in[31:22]};
	    5'd23: res <= {23'b11111111111111111111111,in[31:23]};
	    5'd24: res <= {24'b111111111111111111111111,in[31:24]};
	    5'd25: res <= {25'b1111111111111111111111111,in[31:25]};
	    5'd26: res <= {26'b11111111111111111111111111,in[31:26]};
	    5'd27: res <= {27'b111111111111111111111111111,in[31:27]};
	    5'd28: res <= {28'b1111111111111111111111111111,in[31:28]};
	    5'd29: res <= {29'b11111111111111111111111111111,in[31:29]};
	    5'd30: res <= {30'b111111111111111111111111111111,in[31:30]};
	    5'd31: res <= {31'b1111111111111111111111111111111,in[31]};
	    default: res <= in;
	  endcase 
	else
	  res <= in >> step[4:0];
      else
	res <= in << step[4:0];
   end
   

endmodule 




module k68_par_mul (
   
   res, 
   
   src, dst
   ) ;
   parameter dw =  6'd32;

   output [dw:0] res;
   input [dw/2-1:0] src,dst;

         
endmodule 




module k68_adder (
   
   res, 
   
   src, dst
   ) ;
   parameter dw =  6'd32;

   output [dw:0] res;
   input [dw-1:0] src, dst;
   reg [dw:0] 	  res;

   always @(dst or src) begin
      res <= src + dst;
   end
      
endmodule 




module k68_ccc(
   
   flag, 
   
   cc, code
   );

   parameter XF =  3'd4;
   parameter CF =  3'd0;
   parameter NF =  3'd3;
   parameter ZF =  3'd2;
   parameter VF =  3'd1;
      
   input [7:0] cc;
   input [3:0] code;
   output      flag;
   reg 	       flag;

   always @(cc or code) begin
      case (code)
	4'h4: flag <= ~cc[CF];
	4'h5: flag <= cc[CF];
	4'h7: flag <= cc[ZF];
	4'hC: flag <= cc[NF] & cc[VF] | ~cc[NF] & ~cc[VF];
	4'hE: flag <= cc[NF] & cc[VF] & ~cc[ZF] | ~cc[NF] & ~cc[VF] & ~cc[ZF];
	4'h2: flag <= ~cc[CF] & ~cc[ZF];
	4'hF: flag <= cc[ZF] | cc[NF] & ~cc[VF] | ~cc[NF] & cc[VF];
	4'h3: flag <= cc[CF] | cc[ZF];
	4'hD: flag <= cc[NF] & ~cc[VF] | ~cc[NF] & cc[VF];
	4'hB: flag <= cc[NF];
	4'h6: flag <= ~cc[ZF];
	4'hA: flag <= ~cc[NF];
	4'h8: flag <= ~cc[VF];
	4'h9: flag <= cc[VF];
	4'h1: flag <= 1'b0;
	4'h0: flag <= 1'b1;
	
      endcase 
   end
   
endmodule 




module k68_d2b(
   
   b, 
   
   d
   );
   parameter dw =  6'd32;
   input [7:0] d;
   output [7:0] b;
   reg [7:0] 	b;

   always @ ( d) begin

      if (d[7:4] >= 4'd5)
	b[7:4] <= d[7:4] + 2'd3;
      else
	b[7:4] <= d[7:4];

      if (d[3:0] >= 4'd5)
	b[3:0] <= d[3:0] + 2'd3;
      else
	b[3:0] <= d[3:0];
            
   end
     
   
endmodule 




module k68_b2d(
   
   d, 
   
   b
   );
   parameter dw =  6'd32;
   input [7:0] b;
   output [7:0] d;
   reg [7:0] 	d;

   always @ ( b) begin

      if (b[7:4] >= 4'd5)
	d[7:4] <= b[7:4] - 2'd3;
      else
	d[7:4] <= b[7:4];

      if (b[3:0] >= 4'd5)
	d[3:0] <= b[3:0] - 2'd3;
      else
	d[3:0] <= b[3:0];
            
   end
   
      
endmodule 
 

`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_regbank.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_regbank.v"


module k68_regbank (
   
   rs_dat_o, rt_dat_o, 
   
   rs_add_i, rt_add_i, rd_add_i, clk_i, rst_i, we_i, rd_dat_i
   ) ;

   parameter dw =  6'd32;
   parameter gw =  6'd4;
         
   input [gw-1:0] rs_add_i, rt_add_i, rd_add_i;
   input 	  clk_i, rst_i, we_i;
   
   output [dw-1:0] rs_dat_o, rt_dat_o;
   input [dw-1:0]  rd_dat_i;

   reg [dw-1:0]    w_dat;
   reg [gw-1:0]    w_add;
   reg 		   we;
   
   
   k68_dpmem #(gw,dw) bank0(
		   .clk_i(clk_i), .rst_i(rst_i), .we_i(we),
		   .add_r_i(rs_add_i), .dat_r_o(rs_dat_o),
		   .add_w_i(w_add), .dat_w_i(w_dat)
		   );

   k68_dpmem #(gw,dw) bank1(
		   .clk_i(clk_i), .rst_i(rst_i), .we_i(we),
		   .add_r_i(rt_add_i), .dat_r_o(rt_dat_o),
		   .add_w_i(w_add), .dat_w_i(w_dat)
		   );

   always @(posedge clk_i) begin
      w_add <= rd_add_i;
      w_dat <= rd_dat_i;
      we <= we_i;
   end
      
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_rox.v"




































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 37 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_rox.v"

  



module k68_rox (
   
   res, 
   
   in, step
   ) ;
   parameter dw =  6'd32;
   
   output [dw-1:0] res;
   input [dw-1:0] in;
   input [5:0] 	  step;
   reg [dw-1:0] 	  res;
   reg [4:0] 		  move;
   
   always @ ( step) begin
      if (step[5]) 
	move = 6'd32 - step[4:0];
      else
	move = step[4:0];
   end
   	     
   always @ ( in or move) begin
      
      
      
      case (move)
	5'd01: res = {in[30:0],in[31]};
	5'd02: res = {in[29:0],in[31:30]};
	5'd03: res = {in[28:0],in[31:29]};
	5'd04: res = {in[27:0],in[31:28]};
	5'd05: res = {in[26:0],in[31:27]};
	5'd06: res = {in[25:0],in[31:26]};
	5'd07: res = {in[24:0],in[31:25]};
	5'd08: res = {in[23:0],in[31:24]};
	5'd09: res = {in[22:0],in[31:23]};
	5'd10: res = {in[21:0],in[31:22]};
	5'd11: res = {in[20:0],in[31:21]};
	5'd12: res = {in[19:0],in[31:20]};
	5'd13: res = {in[18:0],in[31:19]};
	5'd14: res = {in[17:0],in[31:18]};
	5'd15: res = {in[16:0],in[31:17]};
	5'd16: res = {in[15:0],in[31:16]};
	5'd17: res = {in[14:0],in[31:15]};
	5'd18: res = {in[13:0],in[31:14]};
	5'd19: res = {in[12:0],in[31:13]};
	5'd20: res = {in[11:0],in[31:12]};
	5'd21: res = {in[10:0],in[31:11]};
	5'd22: res = {in[9:0],in[31:10]};
	5'd23: res = {in[8:0],in[31:9]};
	5'd24: res = {in[7:0],in[31:8]};
	5'd25: res = {in[6:0],in[31:7]};
	5'd26: res = {in[5:0],in[31:6]};
	5'd27: res = {in[4:0],in[31:5]};
	5'd28: res = {in[3:0],in[31:4]};
	5'd29: res = {in[2:0],in[31:3]};
	5'd30: res = {in[1:0],in[31:2]};
	5'd31: res = {in[0],in[31:1]};
	default: res = {in[31:0]};
	
      endcase 
   end

endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_roxx.v"




































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 37 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_roxx.v"

  



module k68_roxx (
   
   res, 
   
   in, xin, step
   ) ;
   parameter dw =  6'd32;
   
   output [dw:0] res;
   input [dw-1:0] in;
   input 	xin;
   input [6:0] 	step;
   reg [dw:0] res;
   reg [5:0] 	move;
   
   always @ ( step) begin
      if (step[6]) 
	move <= 6'd33 - step[5:0];
      else
	move <= step[5:0];
   end
   	     
   always @ ( in or move or xin) begin
      
      
      
      case (move)
	6'd01: res <= {in[30:0],xin,in[31]};
	6'd02: res <= {in[29:0],xin,in[31:30]};
	6'd03: res <= {in[28:0],xin,in[31:29]};
	6'd04: res <= {in[27:0],xin,in[31:28]};
	6'd05: res <= {in[26:0],xin,in[31:27]};
	6'd06: res <= {in[25:0],xin,in[31:26]};
	6'd07: res <= {in[24:0],xin,in[31:25]};
	6'd08: res <= {in[23:0],xin,in[31:24]};
	6'd09: res <= {in[22:0],xin,in[31:23]};
	6'd10: res <= {in[21:0],xin,in[31:22]};
	6'd11: res <= {in[20:0],xin,in[31:21]};
	6'd12: res <= {in[19:0],xin,in[31:20]};
	6'd13: res <= {in[18:0],xin,in[31:19]};
	6'd14: res <= {in[17:0],xin,in[31:18]};
	6'd15: res <= {in[16:0],xin,in[31:17]};
	6'd16: res <= {in[15:0],xin,in[31:16]};
	6'd17: res <= {in[14:0],xin,in[31:15]};
	6'd18: res <= {in[13:0],xin,in[31:14]};
	6'd19: res <= {in[12:0],xin,in[31:13]};
	6'd20: res <= {in[11:0],xin,in[31:12]};
	6'd21: res <= {in[10:0],xin,in[31:11]};
	6'd22: res <= {in[9:0],xin,in[31:10]};
	6'd23: res <= {in[8:0],xin,in[31:9]};
	6'd24: res <= {in[7:0],xin,in[31:8]};
	6'd25: res <= {in[6:0],xin,in[31:7]};
	6'd26: res <= {in[5:0],xin,in[31:6]};
	6'd27: res <= {in[4:0],xin,in[31:5]};
	6'd28: res <= {in[3:0],xin,in[31:4]};
	6'd29: res <= {in[2:0],xin,in[31:3]};
	6'd30: res <= {in[1:0],xin,in[31:2]};
	6'd31: res <= {in[0],xin,in[31:1]};
	6'd32: res <= {xin,in[31:0]};
	default: res <= {in[31:0],xin};
	
      endcase 
   end

endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_sasc.v"


module k68_sasc (
   
   tx_o, rts_o, dat_o, 
   
   clk_i, rst_i, cts_i, rx_i, dat_i, cs_i, we_i
   ) ;

   
   parameter div0 = 8'd1;
   parameter div1 = 8'd217;
      
   input clk_i,rst_i;

   
   output tx_o, rts_o;
   input  cts_i, rx_i;

   
   
   input [23:0] dat_i;
   input       cs_i, we_i;
   output [9:0] dat_o;
   
   
   wire [7:0] 	din;
   wire [7:0] 	dout;
   
   wire 	empty_o,full_o,sio_ce,sio_ce_x4;
   
   wire 	nrst;
   wire [7:0] 	brg0,brg1;
   wire 	re;
   
   assign 	re = cs_i & !we_i;
      
   assign 	{brg1,brg0,din} = dat_i;
   assign 	dat_o = {full_o,empty_o,dout};
   assign 	nrst = ~rst_i;
 
   sasc_top sasc_top0(
		      .rxd_i(rx_i),
		      .txd_o(tx_o),
		      .cts_i(cts_i),
		      .rts_o(rts_o),
		      
		      .sio_ce(sio_ce),
		      .sio_ce_x4(sio_ce_x4),
		      
		      .din_i(din),
		      .dout_o(dout),
		      
		      .re_i(re),
		      .we_i(we_i),
		      
		      .full_o(full_o),
		      .empty_o(empty_o),
		      
		      .clk(clk_i),.rst(nrst)
		      );
   
   sasc_brg sasc_brg0(
		      .sio_ce(sio_ce),
		      .sio_ce_x4(sio_ce_x4),
		      .div0(brg0),
		      .div1(brg1),
		      .clk(clk_i), .rst(nrst)
		      );
   
   
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_soc.v"



































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_defines.v"


























`timescale 1ns / 10ps















































































































































































`line 36 "F:\verilog\bench\verilator_sim_benchmarks\rtl\k68_soc.v"


module k68_soc (
   
   add_o, dat_o, we_o, tx_o, rts_o, clk_o, rst_o, 
   
   dat_i, rst_i, clk_i, arbclk_i, rx_i, cts_i, int_i
   ) ;
   parameter aw =  6'd32;
   parameter dw =  6'd32;

   output [aw-1:0] add_o;
   input [dw-1:0]  dat_i;
   output [dw-1:0] dat_o;
   output 	   we_o;
   
   input 	   rst_i, clk_i;
   input	   arbclk_i;
   input [1:0] 	   rx_i,cts_i;
   output [1:0]    tx_o,rts_o;
   input [2:0] 	   int_i;
   output 	   clk_o;
   output 	   rst_o;
        
   wire 	   cs;
   wire [aw-1:0]   m_add_o;
   wire [dw-1:0]   m_dat_o;
   wire [dw-1:0]   m_dat_i;
   wire 	   m_we_o;
   wire 	   m_cs_o;
   
 	    
   wire [9:0] 	   a_dat_i, b_dat_i;
   wire 	   r_cs_o, r_we_o, a_cs_o, b_cs_o, a_we_o, b_we_o; 	    

   wire		   rst;
   wire [31:0] 	   d_dat_o,d_dat_i;
         
   wire		   arbclk = clk_i;

   assign 	   add_o = m_add_o;
   assign 	   dat_o = m_dat_o;
   assign 	   we_o = r_we_o;
 
   wire 	   unused_g_we_o;
   wire 	   unused_g_cs_o;

   
   
   
   k68_arb arb0 (
		 .m_we_o(r_we_o),
		 .m_cs_o(r_cs_o),
		 .m_dat_i(dat_i),
		 
		 .a_dat_i(a_dat_i),

		 .b_dat_i(b_dat_i),
		 
		 .m_add_i(m_add_o),
		 .m_we_i(m_we_o),
		 .m_dat_o(m_dat_i),

		 .g_we_o(unused_g_we_o),
		 .g_cs_o(unused_g_cs_o),
		 .g_dat_i(16'h0),

		 .rst_i(rst_o),
		 
		 
		 .a_we_o		(a_we_o),
		 .a_cs_o		(a_cs_o),
		 .b_we_o		(b_we_o),
		 .b_cs_o		(b_cs_o),
		 
		 .arbclk		(arbclk));

   
   
   
   k68_cpu cpu0(
		.add_o(m_add_o),
		.dat_o(m_dat_o),
		.dat_i(m_dat_i),
		.we_o(m_we_o),
		
		.int_i(int_i),
		.cs_o(cs),
		.clk_o(clk_o), .rst_o(rst_o),
		.clk_i(clk_i), .rst_i(rst_i)
		);


   

   
   
   

   wire [7:0] 	   brg0,brg1;
   assign 	   brg0 =  8'd1;
   assign 	   brg1 =  8'd217;
      
   k68_sasc uart0(
		  .tx_o(tx_o[0]),
		  .rts_o(rts_o[0]),
		  .dat_i({brg1,brg0,m_dat_o[7:0]}),
		  .dat_o(a_dat_i),
		  .cts_i(cts_i[0]),
		  .rx_i(rx_i[0]),
		  .cs_i(a_cs_o),
		  .we_i(a_we_o),
		  .clk_i(clk_o),.rst_i(rst_o)
		  );
   
   k68_sasc uart1(
		  .tx_o(tx_o[1]),
		  .rts_o(rts_o[1]),
		  .dat_i({brg1,brg0,m_dat_o[7:0]}),
		  .dat_o(b_dat_i),
		  .cts_i(cts_i[1]),
		  .rx_i(rx_i[1]),
		  .cs_i(b_cs_o),
		  .we_i(b_we_o),
		  .clk_i(clk_o),.rst_i(rst_o)
		  );

  
 
endmodule 


`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\sasc_brg.v"




































































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\timescale.v"
`timescale 1ns / 10ps

`line 69 "F:\verilog\bench\verilator_sim_benchmarks\rtl\sasc_brg.v"






















module sasc_brg(clk, rst, div0, div1, sio_ce, sio_ce_x4);
input		clk;
input		rst;
input	[7:0]	div0, div1;
output		sio_ce, sio_ce_x4;






reg	[7:0]	ps;
reg		ps_clr;
reg	[7:0]	br_cnt;
reg		br_clr;
reg		sio_ce_x4_r;
reg	[1:0]	cnt;
reg		sio_ce, sio_ce_x4;
reg		sio_ce_r ;
reg		sio_ce_x4_t;








always @(posedge clk)
	if(!rst)	ps <= #1 8'h0;
	else
	if(ps_clr)	ps <= #1 8'h0;
	else		ps <= #1 ps + 8'h1;

always @(posedge clk)
	ps_clr <= #1 (ps == div0);	



always @(posedge clk)
	if(!rst)	br_cnt <= #1 8'h0;
	else
	if(br_clr)	br_cnt <= #1 8'h0;
	else
	if(ps_clr)	br_cnt <= #1 br_cnt + 8'h1;

always @(posedge clk)
	br_clr <= #1 (br_cnt == div1); 

always @(posedge clk)
	sio_ce_x4_r <= #1 br_clr;

always @(posedge clk)
	sio_ce_x4_t <= #1 !sio_ce_x4_r & br_clr;

always @(posedge clk)
	sio_ce_x4 <= #1 sio_ce_x4_t;



always @(posedge clk)
	if(!rst)			cnt <= #1 2'h0;
	else
	if(!sio_ce_x4_r & br_clr)	cnt <= #1 cnt + 2'h1;

always @(posedge clk)
	sio_ce_r <= #1 (cnt == 2'h0);

always @(posedge clk)
	sio_ce <= #1 !sio_ce_r & (cnt == 2'h0);

endmodule



`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\sasc_fifo4.v"






























































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\timescale.v"
`timescale 1ns / 10ps

`line 63 "F:\verilog\bench\verilator_sim_benchmarks\rtl\sasc_fifo4.v"



module sasc_fifo4(clk, rst, clr,  din, we, dout, re, full, empty);

input		clk, rst;
input		clr;
input   [7:0]	din;
input		we;
output  [7:0]	dout;
input		re;
output		full, empty;







reg     [7:0]	mem[0:3];
reg     [1:0]   wp;
reg     [1:0]   rp;
wire    [1:0]   wp_p1;
wire    [1:0]   wp_p2;
wire    [1:0]   rp_p1;
wire		full, empty;
reg		gb;






always @(posedge clk or negedge rst)
        if(!rst)	wp <= #1 2'h0;
        else
        if(clr)		wp <= #1 2'h0;
        else
        if(we)		wp <= #1 wp_p1;

assign wp_p1 = wp + 2'h1;
assign wp_p2 = wp + 2'h2;

always @(posedge clk or negedge rst)
        if(!rst)	rp <= #1 2'h0;
        else
        if(clr)		rp <= #1 2'h0;
        else
        if(re)		rp <= #1 rp_p1;

assign rp_p1 = rp + 2'h1;


assign  dout = mem[ rp ];


always @(posedge clk)
        if(we)     mem[ wp ] <= #1 din;


assign empty = (wp == rp) & !gb;
assign full  = (wp == rp) &  gb;


always @(posedge clk)
	if(!rst)			gb <= #1 1'b0;
	else
	if(clr)				gb <= #1 1'b0;
	else
	if((wp_p1 == rp) & we)		gb <= #1 1'b1;
	else
	if(re)				gb <= #1 1'b0;

endmodule




`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\sasc_top.v"
































































`line 1 "F:\verilog\bench\verilator_sim_benchmarks\rtl\timescale.v"
`timescale 1ns / 10ps

`line 65 "F:\verilog\bench\verilator_sim_benchmarks\rtl\sasc_top.v"











module sasc_top(	clk, rst,
	
			
			rxd_i, txd_o, cts_i, rts_o, 

			
			sio_ce, sio_ce_x4,

			
			din_i, dout_o, re_i, we_i, full_o, empty_o);

input		clk;
input		rst;
input		rxd_i;
output		txd_o;
input		cts_i;
output		rts_o; 
input		sio_ce;
input		sio_ce_x4;
input	[7:0]	din_i;
output	[7:0]	dout_o;
input		re_i, we_i;
output		full_o, empty_o;






parameter	START_BIT	= 1'b0,
		STOP_BIT	= 1'b1,
		IDLE_BIT	= 1'b1;

wire	[7:0]	txd_p;
reg		load;
reg		load_r;
wire		load_e;
reg	[9:0]	hold_reg;
wire		txf_empty;
reg		txd_o;
reg		shift_en;
reg	[3:0]	tx_bit_cnt;
reg		rxd_s, rxd_r;
wire		start;
reg	[3:0]	rx_bit_cnt;
reg		rx_go;
reg	[9:0]	rxr;
reg		rx_valid, rx_valid_r;
wire		rx_we;
wire		rxf_full;
reg		rts_o;
reg		txf_empty_r;
reg		shift_en_r;
reg		rxd_r1, rxd_r2;
wire		lock_en;
reg		change;
reg		rx_sio_ce_d, rx_sio_ce_r1, rx_sio_ce_r2, rx_sio_ce;
reg	[1:0]	dpll_state, dpll_next_state;






sasc_fifo4 tx_fifo(	.clk(		clk		),
			.rst(		rst		),
			.clr(		1'b0		),
			.din(		din_i		),
			.we(		we_i		),
			.dout(		txd_p		),
			.re(		load_e		),
			.full(		full_o		),
			.empty(		txf_empty	)
			);

sasc_fifo4 rx_fifo(	.clk(		clk		),
			.rst(		rst		),
			.clr(		1'b0		),
			.din(		rxr[9:2]	),
			.we(		rx_we		),
			.dout(		dout_o		),
			.re(		re_i		),
			.full(		rxf_full	),
			.empty(		empty_o		)
			);





always @(posedge clk)
	if(!rst)	txf_empty_r <= #1 1'b1;
	else
	if(sio_ce)	txf_empty_r <= #1 txf_empty;

always @(posedge clk)
	load <= #1 !txf_empty_r & !shift_en & !cts_i;

always @(posedge clk)
	load_r <= #1 load;

assign load_e = load & sio_ce;

always @(posedge clk)
	if(load_e)		hold_reg <= #1 {STOP_BIT, txd_p, START_BIT};
	else
	if(shift_en & sio_ce)	hold_reg <= #1 {IDLE_BIT, hold_reg[9:1]};

always @(posedge clk)
	if(!rst)				txd_o <= #1 IDLE_BIT;
	else
	if(sio_ce)
		if(shift_en | shift_en_r)	txd_o <= #1 hold_reg[0];
		else				txd_o <= #1 IDLE_BIT;

always @(posedge clk)
        if(!rst)		tx_bit_cnt <= #1 4'h9;
	else
	if(load_e)		tx_bit_cnt <= #1 4'h0;
	else
	if(shift_en & sio_ce)	tx_bit_cnt <= #1 tx_bit_cnt + 4'h1;

always @(posedge clk)
	shift_en <= #1 (tx_bit_cnt != 4'h9);

always @(posedge clk)
	if(!rst)	shift_en_r <= #1 1'b0;
	else
	if(sio_ce)	shift_en_r <= #1 shift_en;






always @(posedge clk)
	rxd_s <= #1 rxd_i;

always @(posedge clk)
	rxd_r <= #1 rxd_s;

assign start = (rxd_r == IDLE_BIT) & (rxd_s == START_BIT);

always @(posedge clk)
        if(!rst)		rx_bit_cnt <= #1 4'ha;
	else
	if(!rx_go & start)	rx_bit_cnt <= #1 4'h0;
	else
	if(rx_go & rx_sio_ce)	rx_bit_cnt <= #1 rx_bit_cnt + 4'h1;

always @(posedge clk)
	rx_go <= #1 (rx_bit_cnt != 4'ha);

always @(posedge clk)
	rx_valid <= #1 (rx_bit_cnt == 4'h9);

always @(posedge clk)
	rx_valid_r <= #1 rx_valid;

assign rx_we = !rx_valid_r & rx_valid & !rxf_full;

always @(posedge clk)
	if(rx_go & rx_sio_ce)	rxr <= {rxd_s, rxr[9:1]};

always @(posedge clk)
	rts_o <= #1 rxf_full;









always @(posedge clk)
	if(sio_ce_x4)	rxd_r1 <= #1 rxd_s;

always @(posedge clk)
	if(sio_ce_x4)	rxd_r2 <= #1 rxd_r1;

always @(posedge clk)
	if(!rst)		change <= #1 1'b0;
	else
	if(rxd_r != rxd_s)	change <= #1 1'b1;
	else
	if(sio_ce_x4)		change <= #1 1'b0;


always @(posedge clk or negedge rst)
	if(!rst)	dpll_state <= #1 2'h1;
	else
	if(sio_ce_x4)	dpll_state <= #1 dpll_next_state;

always @(dpll_state or change)
   begin
	rx_sio_ce_d = 1'b0;
	case(dpll_state)
	   2'h0:
		if(change)	dpll_next_state = 3'h0;
		else		dpll_next_state = 3'h1;
	   2'h1:begin
		rx_sio_ce_d = 1'b1;
		if(change)	dpll_next_state = 3'h3;
		else		dpll_next_state = 3'h2;
		end
	   2'h2:
		if(change)	dpll_next_state = 3'h0;
		else		dpll_next_state = 3'h3;
	   2'h3:
		if(change)	dpll_next_state = 3'h0;
		else		dpll_next_state = 3'h0;
	endcase
   end



always @(posedge clk)
	rx_sio_ce_r1 <= #1 rx_sio_ce_d;

always @(posedge clk)
	rx_sio_ce_r2 <= #1 rx_sio_ce_r1;

always @(posedge clk)
	rx_sio_ce <= #1 rx_sio_ce_r1 & !rx_sio_ce_r2;

endmodule





